/* preferences-dialog.c generated by valac 0.46.1, the Vala compiler
 * generated from preferences-dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Gabriel Ivascu <ivascu.gabriel59@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

#define TYPE_PREFERENCES_DIALOG (preferences_dialog_get_type ())
#define PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialog))
#define PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))
#define IS_PREFERENCES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFERENCES_DIALOG))
#define IS_PREFERENCES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFERENCES_DIALOG))
#define PREFERENCES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFERENCES_DIALOG, PreferencesDialogClass))

typedef struct _PreferencesDialog PreferencesDialog;
typedef struct _PreferencesDialogClass PreferencesDialogClass;
typedef struct _PreferencesDialogPrivate PreferencesDialogPrivate;
enum  {
	PREFERENCES_DIALOG_0_PROPERTY,
	PREFERENCES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* preferences_dialog_properties[PREFERENCES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PreferencesDialog {
	GtkDialog parent_instance;
	PreferencesDialogPrivate * priv;
};

struct _PreferencesDialogClass {
	GtkDialogClass parent_class;
};

struct _PreferencesDialogPrivate {
	GtkApplicationWindow* window;
	GSettings* settings;
	GeeArrayList* worm_settings;
	GtkNotebook* notebook;
	GtkRadioButton* beginner_radio_button;
	GtkRadioButton* slow_radio_button;
	GtkRadioButton* medium_radio_button;
	GtkRadioButton* fast_radio_button;
	GtkCheckButton* sound_check_button;
	GtkCheckButton* fakes_check_button;
	GtkListStore* list_store_1;
	GtkListStore* list_store_2;
	GtkListStore* list_store_3;
	GtkListStore* list_store_4;
	GtkTreeView* tree_view_1;
	GtkTreeView* tree_view_2;
	GtkTreeView* tree_view_3;
	GtkTreeView* tree_view_4;
	GtkComboBoxText* combo_box_1;
	GtkComboBoxText* combo_box_2;
	GtkComboBoxText* combo_box_3;
	GtkComboBoxText* combo_box_4;
	GeeArrayList* radio_buttons;
	GeeArrayList* list_stores;
	GeeArrayList* tree_views;
	GeeArrayList* combo_boxes;
};

static gint PreferencesDialog_private_offset;
static gpointer preferences_dialog_parent_class = NULL;

GType preferences_dialog_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PreferencesDialog, g_object_unref)
PreferencesDialog* preferences_dialog_new (GtkApplicationWindow* window,
                                           GSettings* settings,
                                           GeeArrayList* worm_settings);
PreferencesDialog* preferences_dialog_construct (GType object_type,
                                                 GtkApplicationWindow* window,
                                                 GSettings* settings,
                                                 GeeArrayList* worm_settings);
static void __lambda4_ (PreferencesDialog* self);
static void ___lambda4__gtk_dialog_response (GtkDialog* _sender,
                                      gint response_id,
                                      gpointer self);
#define NIBBLES_GAME_MAX_SPEED 4
static void preferences_dialog_radio_button_toggled_cb (PreferencesDialog* self,
                                                 GtkToggleButton* button);
static void _preferences_dialog_radio_button_toggled_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                            gpointer self);
static void preferences_dialog_sound_toggled_cb (PreferencesDialog* self);
static void _preferences_dialog_sound_toggled_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                     gpointer self);
static void preferences_dialog_fakes_toggles_cb (PreferencesDialog* self);
static void _preferences_dialog_fakes_toggles_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                     gpointer self);
static void preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                         GtkCellRendererAccel* cell,
                                         const gchar* path_string,
                                         guint keyval,
                                         GdkModifierType mask,
                                         guint hardware_keycode);
static void _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                               const gchar* path_string,
                                                                               guint accel_key,
                                                                               GdkModifierType accel_mods,
                                                                               guint hardware_keycode,
                                                                               gpointer self);
static void preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                          GtkCellRendererAccel* cell,
                                          const gchar* path_string);
static void _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                                 const gchar* path_string,
                                                                                 gpointer self);
#define NIBBLES_VIEW_NUM_COLORS 6
gchar* nibbles_view_colorval_name (gint colorval);
static void preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                              GtkComboBox* combo_box);
static void _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                     gpointer self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
#define NIBBLES_GAME_MAX_HUMANS 4
#define NIBBLES_GAME_MAX_WORMS 6
static void preferences_dialog_finalize (GObject * obj);

static inline gpointer
preferences_dialog_get_instance_private (PreferencesDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PreferencesDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda4_ (PreferencesDialog* self)
{
	gtk_widget_destroy ((GtkWidget*) self);
}

static void
___lambda4__gtk_dialog_response (GtkDialog* _sender,
                                 gint response_id,
                                 gpointer self)
{
	__lambda4_ ((PreferencesDialog*) self);
}

static void
_preferences_dialog_radio_button_toggled_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self)
{
	preferences_dialog_radio_button_toggled_cb ((PreferencesDialog*) self, _sender);
}

static void
_preferences_dialog_sound_toggled_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                gpointer self)
{
	preferences_dialog_sound_toggled_cb ((PreferencesDialog*) self);
}

static void
_preferences_dialog_fakes_toggles_cb_gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                gpointer self)
{
	preferences_dialog_fakes_toggles_cb ((PreferencesDialog*) self);
}

static void
_preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited (GtkCellRendererAccel* _sender,
                                                                          const gchar* path_string,
                                                                          guint accel_key,
                                                                          GdkModifierType accel_mods,
                                                                          guint hardware_keycode,
                                                                          gpointer self)
{
	preferences_dialog_accel_edited_cb ((PreferencesDialog*) self, _sender, path_string, accel_key, accel_mods, hardware_keycode);
}

static void
_preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared (GtkCellRendererAccel* _sender,
                                                                            const gchar* path_string,
                                                                            gpointer self)
{
	preferences_dialog_accel_cleared_cb ((PreferencesDialog*) self, _sender, path_string);
}

static void
_preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self)
{
	preferences_dialog_combo_box_changed_cb ((PreferencesDialog*) self, _sender);
}

PreferencesDialog*
preferences_dialog_construct (GType object_type,
                              GtkApplicationWindow* window,
                              GSettings* settings,
                              GeeArrayList* worm_settings)
{
	PreferencesDialog * self = NULL;
	GSettings* _tmp0_;
	GeeArrayList* _tmp1_;
	GtkApplicationWindow* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GtkRadioButton* _tmp5_;
	GeeArrayList* _tmp6_;
	GtkRadioButton* _tmp7_;
	GeeArrayList* _tmp8_;
	GtkRadioButton* _tmp9_;
	GeeArrayList* _tmp10_;
	GtkRadioButton* _tmp11_;
	GtkCheckButton* _tmp23_;
	GtkCheckButton* _tmp24_;
	GtkCheckButton* _tmp25_;
	GtkCheckButton* _tmp26_;
	GeeArrayList* _tmp27_;
	GeeArrayList* _tmp28_;
	GtkTreeView* _tmp29_;
	GeeArrayList* _tmp30_;
	GtkTreeView* _tmp31_;
	GeeArrayList* _tmp32_;
	GtkTreeView* _tmp33_;
	GeeArrayList* _tmp34_;
	GtkTreeView* _tmp35_;
	GeeArrayList* _tmp36_;
	GeeArrayList* _tmp37_;
	GtkListStore* _tmp38_;
	GeeArrayList* _tmp39_;
	GtkListStore* _tmp40_;
	GeeArrayList* _tmp41_;
	GtkListStore* _tmp42_;
	GeeArrayList* _tmp43_;
	GtkListStore* _tmp44_;
	GeeArrayList* _tmp91_;
	GeeArrayList* _tmp92_;
	GtkComboBoxText* _tmp93_;
	GeeArrayList* _tmp94_;
	GtkComboBoxText* _tmp95_;
	GeeArrayList* _tmp96_;
	GtkComboBoxText* _tmp97_;
	GeeArrayList* _tmp98_;
	GtkComboBoxText* _tmp99_;
	g_return_val_if_fail (window != NULL, NULL);
	g_return_val_if_fail (settings != NULL, NULL);
	g_return_val_if_fail (worm_settings != NULL, NULL);
	self = (PreferencesDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
	_tmp0_ = _g_object_ref0 (settings);
	_g_object_unref0 (self->priv->settings);
	self->priv->settings = _tmp0_;
	_tmp1_ = _g_object_ref0 (worm_settings);
	_g_object_unref0 (self->priv->worm_settings);
	self->priv->worm_settings = _tmp1_;
	_tmp2_ = _g_object_ref0 (window);
	_g_object_unref0 (self->priv->window);
	self->priv->window = _tmp2_;
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) ___lambda4__gtk_dialog_response, self, 0);
	gtk_window_set_transient_for ((GtkWindow*) self, (GtkWindow*) window);
	_tmp3_ = gee_array_list_new (gtk_radio_button_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->radio_buttons);
	self->priv->radio_buttons = _tmp3_;
	_tmp4_ = self->priv->radio_buttons;
	_tmp5_ = self->priv->beginner_radio_button;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, _tmp5_);
	_tmp6_ = self->priv->radio_buttons;
	_tmp7_ = self->priv->slow_radio_button;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, _tmp7_);
	_tmp8_ = self->priv->radio_buttons;
	_tmp9_ = self->priv->medium_radio_button;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp8_, _tmp9_);
	_tmp10_ = self->priv->radio_buttons;
	_tmp11_ = self->priv->fast_radio_button;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
	{
		GeeArrayList* _radio_button_list = NULL;
		GeeArrayList* _tmp12_;
		GeeArrayList* _tmp13_;
		gint _radio_button_size = 0;
		GeeArrayList* _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
		gint _radio_button_index = 0;
		_tmp12_ = self->priv->radio_buttons;
		_tmp13_ = _g_object_ref0 (_tmp12_);
		_radio_button_list = _tmp13_;
		_tmp14_ = _radio_button_list;
		_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
		_tmp16_ = _tmp15_;
		_radio_button_size = _tmp16_;
		_radio_button_index = -1;
		while (TRUE) {
			GtkRadioButton* radio_button = NULL;
			GeeArrayList* _tmp17_;
			gpointer _tmp18_;
			gint speed = 0;
			GeeArrayList* _tmp19_;
			GtkRadioButton* _tmp20_;
			GtkRadioButton* _tmp21_;
			GtkRadioButton* _tmp22_;
			_radio_button_index = _radio_button_index + 1;
			if (!(_radio_button_index < _radio_button_size)) {
				break;
			}
			_tmp17_ = _radio_button_list;
			_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _radio_button_index);
			radio_button = (GtkRadioButton*) _tmp18_;
			_tmp19_ = self->priv->radio_buttons;
			_tmp20_ = radio_button;
			speed = NIBBLES_GAME_MAX_SPEED - gee_abstract_list_index_of ((GeeAbstractList*) _tmp19_, _tmp20_);
			_tmp21_ = radio_button;
			gtk_toggle_button_set_active ((GtkToggleButton*) _tmp21_, speed == g_settings_get_int (settings, "speed"));
			_tmp22_ = radio_button;
			g_signal_connect_object ((GtkToggleButton*) _tmp22_, "toggled", (GCallback) _preferences_dialog_radio_button_toggled_cb_gtk_toggle_button_toggled, self, 0);
			_g_object_unref0 (radio_button);
		}
		_g_object_unref0 (_radio_button_list);
	}
	_tmp23_ = self->priv->sound_check_button;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp23_, g_settings_get_boolean (settings, "sound"));
	_tmp24_ = self->priv->sound_check_button;
	g_signal_connect_object ((GtkToggleButton*) _tmp24_, "toggled", (GCallback) _preferences_dialog_sound_toggled_cb_gtk_toggle_button_toggled, self, 0);
	_tmp25_ = self->priv->fakes_check_button;
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp25_, g_settings_get_boolean (settings, "fakes"));
	_tmp26_ = self->priv->fakes_check_button;
	g_signal_connect_object ((GtkToggleButton*) _tmp26_, "toggled", (GCallback) _preferences_dialog_fakes_toggles_cb_gtk_toggle_button_toggled, self, 0);
	_tmp27_ = gee_array_list_new (gtk_tree_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->tree_views);
	self->priv->tree_views = _tmp27_;
	_tmp28_ = self->priv->tree_views;
	_tmp29_ = self->priv->tree_view_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp29_);
	_tmp30_ = self->priv->tree_views;
	_tmp31_ = self->priv->tree_view_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
	_tmp32_ = self->priv->tree_views;
	_tmp33_ = self->priv->tree_view_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp32_, _tmp33_);
	_tmp34_ = self->priv->tree_views;
	_tmp35_ = self->priv->tree_view_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
	_tmp36_ = gee_array_list_new (gtk_list_store_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->list_stores);
	self->priv->list_stores = _tmp36_;
	_tmp37_ = self->priv->list_stores;
	_tmp38_ = self->priv->list_store_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp37_, _tmp38_);
	_tmp39_ = self->priv->list_stores;
	_tmp40_ = self->priv->list_store_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp39_, _tmp40_);
	_tmp41_ = self->priv->list_stores;
	_tmp42_ = self->priv->list_store_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp41_, _tmp42_);
	_tmp43_ = self->priv->list_stores;
	_tmp44_ = self->priv->list_store_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp43_, _tmp44_);
	{
		GeeArrayList* _list_store_list = NULL;
		GeeArrayList* _tmp45_;
		GeeArrayList* _tmp46_;
		gint _list_store_size = 0;
		GeeArrayList* _tmp47_;
		gint _tmp48_;
		gint _tmp49_;
		gint _list_store_index = 0;
		_tmp45_ = self->priv->list_stores;
		_tmp46_ = _g_object_ref0 (_tmp45_);
		_list_store_list = _tmp46_;
		_tmp47_ = _list_store_list;
		_tmp48_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp47_);
		_tmp49_ = _tmp48_;
		_list_store_size = _tmp49_;
		_list_store_index = -1;
		while (TRUE) {
			GtkListStore* list_store = NULL;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
			gint id = 0;
			GeeArrayList* _tmp52_;
			GtkListStore* _tmp53_;
			GtkTreeView* tree_view = NULL;
			GeeArrayList* _tmp54_;
			gpointer _tmp55_;
			GtkTreeIter iter = {0};
			GtkListStore* _tmp56_;
			GtkTreeIter _tmp57_ = {0};
			gint keyval = 0;
			gpointer _tmp58_;
			GSettings* _tmp59_;
			gint _tmp60_;
			GtkListStore* _tmp61_;
			GtkTreeIter _tmp62_;
			GtkListStore* _tmp63_;
			GtkTreeIter _tmp64_ = {0};
			gpointer _tmp65_;
			GSettings* _tmp66_;
			GtkListStore* _tmp67_;
			GtkTreeIter _tmp68_;
			GtkListStore* _tmp69_;
			GtkTreeIter _tmp70_ = {0};
			gpointer _tmp71_;
			GSettings* _tmp72_;
			GtkListStore* _tmp73_;
			GtkTreeIter _tmp74_;
			GtkListStore* _tmp75_;
			GtkTreeIter _tmp76_ = {0};
			gpointer _tmp77_;
			GSettings* _tmp78_;
			GtkListStore* _tmp79_;
			GtkTreeIter _tmp80_;
			GtkCellRendererText* label_renderer = NULL;
			GtkCellRendererText* _tmp81_;
			GtkTreeView* _tmp82_;
			GtkCellRendererText* _tmp83_;
			GtkCellRendererAccel* key_renderer = NULL;
			GtkCellRendererAccel* _tmp84_;
			GtkCellRendererAccel* _tmp85_;
			GtkCellRendererAccel* _tmp86_;
			GtkCellRendererAccel* _tmp87_;
			GtkCellRendererAccel* _tmp88_;
			GtkTreeView* _tmp89_;
			GtkCellRendererAccel* _tmp90_;
			_list_store_index = _list_store_index + 1;
			if (!(_list_store_index < _list_store_size)) {
				break;
			}
			_tmp50_ = _list_store_list;
			_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) _tmp50_, _list_store_index);
			list_store = (GtkListStore*) _tmp51_;
			_tmp52_ = self->priv->list_stores;
			_tmp53_ = list_store;
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp52_, _tmp53_);
			_tmp54_ = self->priv->tree_views;
			_tmp55_ = gee_abstract_list_get ((GeeAbstractList*) _tmp54_, id);
			tree_view = (GtkTreeView*) _tmp55_;
			_tmp56_ = list_store;
			gtk_list_store_append (_tmp56_, &_tmp57_);
			iter = _tmp57_;
			_tmp58_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp59_ = (GSettings*) _tmp58_;
			_tmp60_ = g_settings_get_int (_tmp59_, "key-up");
			_g_object_unref0 (_tmp59_);
			keyval = _tmp60_;
			_tmp61_ = list_store;
			_tmp62_ = iter;
			gtk_list_store_set (_tmp61_, &_tmp62_, 0, "key-up", 1, _ ("Move up"), 2, keyval, -1);
			_tmp63_ = list_store;
			gtk_list_store_append (_tmp63_, &_tmp64_);
			iter = _tmp64_;
			_tmp65_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp66_ = (GSettings*) _tmp65_;
			keyval = g_settings_get_int (_tmp66_, "key-down");
			_g_object_unref0 (_tmp66_);
			_tmp67_ = list_store;
			_tmp68_ = iter;
			gtk_list_store_set (_tmp67_, &_tmp68_, 0, "key-down", 1, _ ("Move down"), 2, keyval, -1);
			_tmp69_ = list_store;
			gtk_list_store_append (_tmp69_, &_tmp70_);
			iter = _tmp70_;
			_tmp71_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp72_ = (GSettings*) _tmp71_;
			keyval = g_settings_get_int (_tmp72_, "key-left");
			_g_object_unref0 (_tmp72_);
			_tmp73_ = list_store;
			_tmp74_ = iter;
			gtk_list_store_set (_tmp73_, &_tmp74_, 0, "key-left", 1, _ ("Move left"), 2, keyval, -1);
			_tmp75_ = list_store;
			gtk_list_store_append (_tmp75_, &_tmp76_);
			iter = _tmp76_;
			_tmp77_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp78_ = (GSettings*) _tmp77_;
			keyval = g_settings_get_int (_tmp78_, "key-right");
			_g_object_unref0 (_tmp78_);
			_tmp79_ = list_store;
			_tmp80_ = iter;
			gtk_list_store_set (_tmp79_, &_tmp80_, 0, "key-right", 1, _ ("Move right"), 2, keyval, -1);
			_tmp81_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
			g_object_ref_sink (_tmp81_);
			label_renderer = _tmp81_;
			_tmp82_ = tree_view;
			_tmp83_ = label_renderer;
			gtk_tree_view_insert_column_with_attributes (_tmp82_, -1, _ ("Action"), (GtkCellRenderer*) _tmp83_, "text", 1, NULL);
			_tmp84_ = (GtkCellRendererAccel*) gtk_cell_renderer_accel_new ();
			g_object_ref_sink (_tmp84_);
			key_renderer = _tmp84_;
			_tmp85_ = key_renderer;
			g_object_set ((GtkCellRendererText*) _tmp85_, "editable", TRUE, NULL);
			_tmp86_ = key_renderer;
			g_object_set (_tmp86_, "accel-mode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER, NULL);
			_tmp87_ = key_renderer;
			g_signal_connect_object (_tmp87_, "accel-edited", (GCallback) _preferences_dialog_accel_edited_cb_gtk_cell_renderer_accel_accel_edited, self, 0);
			_tmp88_ = key_renderer;
			g_signal_connect_object (_tmp88_, "accel-cleared", (GCallback) _preferences_dialog_accel_cleared_cb_gtk_cell_renderer_accel_accel_cleared, self, 0);
			_tmp89_ = tree_view;
			_tmp90_ = key_renderer;
			gtk_tree_view_insert_column_with_attributes (_tmp89_, -1, _ ("Key"), (GtkCellRenderer*) _tmp90_, "accel-key", 2, NULL);
			_g_object_unref0 (key_renderer);
			_g_object_unref0 (label_renderer);
			_g_object_unref0 (tree_view);
			_g_object_unref0 (list_store);
		}
		_g_object_unref0 (_list_store_list);
	}
	_tmp91_ = gee_array_list_new (gtk_combo_box_text_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->combo_boxes);
	self->priv->combo_boxes = _tmp91_;
	_tmp92_ = self->priv->combo_boxes;
	_tmp93_ = self->priv->combo_box_1;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp92_, _tmp93_);
	_tmp94_ = self->priv->combo_boxes;
	_tmp95_ = self->priv->combo_box_2;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp94_, _tmp95_);
	_tmp96_ = self->priv->combo_boxes;
	_tmp97_ = self->priv->combo_box_3;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp96_, _tmp97_);
	_tmp98_ = self->priv->combo_boxes;
	_tmp99_ = self->priv->combo_box_4;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, _tmp99_);
	{
		GeeArrayList* _combo_box_list = NULL;
		GeeArrayList* _tmp100_;
		GeeArrayList* _tmp101_;
		gint _combo_box_size = 0;
		GeeArrayList* _tmp102_;
		gint _tmp103_;
		gint _tmp104_;
		gint _combo_box_index = 0;
		_tmp100_ = self->priv->combo_boxes;
		_tmp101_ = _g_object_ref0 (_tmp100_);
		_combo_box_list = _tmp101_;
		_tmp102_ = _combo_box_list;
		_tmp103_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp102_);
		_tmp104_ = _tmp103_;
		_combo_box_size = _tmp104_;
		_combo_box_index = -1;
		while (TRUE) {
			GtkComboBoxText* combo_box = NULL;
			GeeArrayList* _tmp105_;
			gpointer _tmp106_;
			gint id = 0;
			GeeArrayList* _tmp112_;
			GtkComboBoxText* _tmp113_;
			gint color = 0;
			gpointer _tmp114_;
			GSettings* _tmp115_;
			gint _tmp116_;
			GtkComboBoxText* _tmp117_;
			GtkComboBoxText* _tmp118_;
			_combo_box_index = _combo_box_index + 1;
			if (!(_combo_box_index < _combo_box_size)) {
				break;
			}
			_tmp105_ = _combo_box_list;
			_tmp106_ = gee_abstract_list_get ((GeeAbstractList*) _tmp105_, _combo_box_index);
			combo_box = (GtkComboBoxText*) _tmp106_;
			{
				gint i = 0;
				i = 0;
				{
					gboolean _tmp107_ = FALSE;
					_tmp107_ = TRUE;
					while (TRUE) {
						GtkComboBoxText* _tmp109_;
						gchar* _tmp110_;
						gchar* _tmp111_;
						if (!_tmp107_) {
							gint _tmp108_;
							_tmp108_ = i;
							i = _tmp108_ + 1;
						}
						_tmp107_ = FALSE;
						if (!(i < NIBBLES_VIEW_NUM_COLORS)) {
							break;
						}
						_tmp109_ = combo_box;
						_tmp110_ = nibbles_view_colorval_name (i);
						_tmp111_ = _tmp110_;
						gtk_combo_box_text_append_text (_tmp109_, _tmp111_);
						_g_free0 (_tmp111_);
					}
				}
			}
			_tmp112_ = self->priv->combo_boxes;
			_tmp113_ = combo_box;
			id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp112_, _tmp113_);
			_tmp114_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, id);
			_tmp115_ = (GSettings*) _tmp114_;
			_tmp116_ = g_settings_get_enum (_tmp115_, "color");
			_g_object_unref0 (_tmp115_);
			color = _tmp116_;
			_tmp117_ = combo_box;
			gtk_combo_box_set_active ((GtkComboBox*) _tmp117_, color);
			_tmp118_ = combo_box;
			g_signal_connect_object ((GtkComboBox*) _tmp118_, "changed", (GCallback) _preferences_dialog_combo_box_changed_cb_gtk_combo_box_changed, self, 0);
			_g_object_unref0 (combo_box);
		}
		_g_object_unref0 (_combo_box_list);
	}
	return self;
}

PreferencesDialog*
preferences_dialog_new (GtkApplicationWindow* window,
                        GSettings* settings,
                        GeeArrayList* worm_settings)
{
	return preferences_dialog_construct (TYPE_PREFERENCES_DIALOG, window, settings, worm_settings);
}

static void
preferences_dialog_radio_button_toggled_cb (PreferencesDialog* self,
                                            GtkToggleButton* button)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (button != NULL);
	if (gtk_toggle_button_get_active (button)) {
		gint speed = 0;
		GeeArrayList* _tmp0_;
		GSettings* _tmp1_;
		_tmp0_ = self->priv->radio_buttons;
		speed = NIBBLES_GAME_MAX_SPEED - gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (button, gtk_radio_button_get_type (), GtkRadioButton));
		_tmp1_ = self->priv->settings;
		g_settings_set_int (_tmp1_, "speed", speed);
	}
}

static void
preferences_dialog_sound_toggled_cb (PreferencesDialog* self)
{
	gboolean play_sound = FALSE;
	GtkCheckButton* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->sound_check_button;
	play_sound = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp1_ = self->priv->settings;
	g_settings_set_boolean (_tmp1_, "sound", play_sound);
}

static void
preferences_dialog_fakes_toggles_cb (PreferencesDialog* self)
{
	gboolean has_fakes = FALSE;
	GtkCheckButton* _tmp0_;
	GSettings* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->fakes_check_button;
	has_fakes = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
	_tmp1_ = self->priv->settings;
	g_settings_set_boolean (_tmp1_, "fakes", has_fakes);
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
	g_boxed_free (gtk_tree_path_get_type (), self);
}

static void
preferences_dialog_accel_edited_cb (PreferencesDialog* self,
                                    GtkCellRendererAccel* cell,
                                    const gchar* path_string,
                                    guint keyval,
                                    GdkModifierType mask,
                                    guint hardware_keycode)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkNotebook* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GeeArrayList* _tmp13_;
	gpointer _tmp14_;
	GSettings* _tmp15_;
	const gchar* _tmp16_;
	gboolean _tmp17_;
	gboolean valid = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->notebook;
	id = gtk_notebook_get_current_page (_tmp2_) - 1;
	_tmp3_ = self->priv->list_stores;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
	list_store = (GtkListStore*) _tmp4_;
	_tmp5_ = list_store;
	_tmp6_ = path;
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
	it = _tmp7_;
	if (!_tmp8_) {
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	key = NULL;
	_tmp9_ = list_store;
	_tmp10_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
	_g_free0 (key);
	key = _tmp11_;
	_tmp12_ = key;
	if (_tmp12_ == NULL) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp13_ = self->priv->worm_settings;
	_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, id);
	_tmp15_ = (GSettings*) _tmp14_;
	_tmp16_ = key;
	_tmp17_ = ((guint) g_settings_get_int (_tmp15_, _tmp16_)) == keyval;
	_g_object_unref0 (_tmp15_);
	if (_tmp17_) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	valid = TRUE;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp18_ = FALSE;
			_tmp18_ = TRUE;
			while (TRUE) {
				gboolean _tmp20_ = FALSE;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				GeeArrayList* _tmp23_;
				gpointer _tmp24_;
				GSettings* _tmp25_;
				gboolean _tmp26_;
				if (!_tmp18_) {
					gint _tmp19_;
					_tmp19_ = i;
					i = _tmp19_ + 1;
				}
				_tmp18_ = FALSE;
				if (!(i < NIBBLES_GAME_MAX_HUMANS)) {
					break;
				}
				_tmp23_ = self->priv->worm_settings;
				_tmp24_ = gee_abstract_list_get ((GeeAbstractList*) _tmp23_, i);
				_tmp25_ = (GSettings*) _tmp24_;
				_tmp26_ = ((guint) g_settings_get_int (_tmp25_, "key-up")) == keyval;
				_g_object_unref0 (_tmp25_);
				if (_tmp26_) {
					_tmp22_ = TRUE;
				} else {
					GeeArrayList* _tmp27_;
					gpointer _tmp28_;
					GSettings* _tmp29_;
					_tmp27_ = self->priv->worm_settings;
					_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, i);
					_tmp29_ = (GSettings*) _tmp28_;
					_tmp22_ = ((guint) g_settings_get_int (_tmp29_, "key-down")) == keyval;
					_g_object_unref0 (_tmp29_);
				}
				if (_tmp22_) {
					_tmp21_ = TRUE;
				} else {
					GeeArrayList* _tmp30_;
					gpointer _tmp31_;
					GSettings* _tmp32_;
					_tmp30_ = self->priv->worm_settings;
					_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, i);
					_tmp32_ = (GSettings*) _tmp31_;
					_tmp21_ = ((guint) g_settings_get_int (_tmp32_, "key-left")) == keyval;
					_g_object_unref0 (_tmp32_);
				}
				if (_tmp21_) {
					_tmp20_ = TRUE;
				} else {
					GeeArrayList* _tmp33_;
					gpointer _tmp34_;
					GSettings* _tmp35_;
					_tmp33_ = self->priv->worm_settings;
					_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, i);
					_tmp35_ = (GSettings*) _tmp34_;
					_tmp20_ = ((guint) g_settings_get_int (_tmp35_, "key-right")) == keyval;
					_g_object_unref0 (_tmp35_);
				}
				if (_tmp20_) {
					GtkMessageDialog* dialog = NULL;
					GtkApplicationWindow* _tmp36_;
					GtkMessageDialog* _tmp37_;
					GtkMessageDialog* _tmp38_;
					GtkMessageDialog* _tmp39_;
					valid = FALSE;
					_tmp36_ = self->priv->window;
					_tmp37_ = (GtkMessageDialog*) gtk_message_dialog_new ((GtkWindow*) _tmp36_, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_WARNING, GTK_BUTTONS_OK, "%s", _ ("The key you selected is already assigned!"));
					g_object_ref_sink (_tmp37_);
					dialog = _tmp37_;
					_tmp38_ = dialog;
					gtk_dialog_run ((GtkDialog*) _tmp38_);
					_tmp39_ = dialog;
					gtk_widget_destroy ((GtkWidget*) _tmp39_);
					_g_object_unref0 (dialog);
					break;
				}
			}
		}
	}
	if (valid) {
		GtkListStore* _tmp40_;
		GtkTreeIter _tmp41_;
		GeeArrayList* _tmp42_;
		gpointer _tmp43_;
		GSettings* _tmp44_;
		const gchar* _tmp45_;
		_tmp40_ = list_store;
		_tmp41_ = it;
		gtk_list_store_set (_tmp40_, &_tmp41_, 2, keyval, -1);
		_tmp42_ = self->priv->worm_settings;
		_tmp43_ = gee_abstract_list_get ((GeeAbstractList*) _tmp42_, id);
		_tmp44_ = (GSettings*) _tmp43_;
		_tmp45_ = key;
		g_settings_set_int (_tmp44_, _tmp45_, (gint) keyval);
		_g_object_unref0 (_tmp44_);
	}
	_g_free0 (key);
	_g_object_unref0 (list_store);
	__vala_GtkTreePath_free0 (path);
}

static void
preferences_dialog_accel_cleared_cb (PreferencesDialog* self,
                                     GtkCellRendererAccel* cell,
                                     const gchar* path_string)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	GtkTreePath* _tmp1_;
	gint id = 0;
	GtkNotebook* _tmp2_;
	GtkListStore* list_store = NULL;
	GeeArrayList* _tmp3_;
	gpointer _tmp4_;
	GtkTreeIter it = {0};
	GtkListStore* _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreeIter _tmp7_ = {0};
	gboolean _tmp8_;
	gchar* key = NULL;
	GtkListStore* _tmp9_;
	GtkTreeIter _tmp10_;
	gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GtkListStore* _tmp13_;
	GtkTreeIter _tmp14_;
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	GSettings* _tmp17_;
	const gchar* _tmp18_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (cell != NULL);
	g_return_if_fail (path_string != NULL);
	_tmp0_ = gtk_tree_path_new_from_string (path_string);
	path = _tmp0_;
	_tmp1_ = path;
	if (_tmp1_ == NULL) {
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp2_ = self->priv->notebook;
	id = gtk_notebook_get_current_page (_tmp2_) - 1;
	_tmp3_ = self->priv->list_stores;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp3_, id);
	list_store = (GtkListStore*) _tmp4_;
	_tmp5_ = list_store;
	_tmp6_ = path;
	_tmp8_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
	it = _tmp7_;
	if (!_tmp8_) {
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	key = NULL;
	_tmp9_ = list_store;
	_tmp10_ = it;
	gtk_tree_model_get ((GtkTreeModel*) _tmp9_, &_tmp10_, 0, &_tmp11_, -1);
	_g_free0 (key);
	key = _tmp11_;
	_tmp12_ = key;
	if (_tmp12_ == NULL) {
		_g_free0 (key);
		_g_object_unref0 (list_store);
		__vala_GtkTreePath_free0 (path);
		return;
	}
	_tmp13_ = list_store;
	_tmp14_ = it;
	gtk_list_store_set (_tmp13_, &_tmp14_, 2, 0, -1);
	_tmp15_ = self->priv->worm_settings;
	_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, id);
	_tmp17_ = (GSettings*) _tmp16_;
	_tmp18_ = key;
	g_settings_set_int (_tmp17_, _tmp18_, 0);
	_g_object_unref0 (_tmp17_);
	_g_free0 (key);
	_g_object_unref0 (list_store);
	__vala_GtkTreePath_free0 (path);
}

static void
preferences_dialog_combo_box_changed_cb (PreferencesDialog* self,
                                         GtkComboBox* combo_box)
{
	gint id = 0;
	GeeArrayList* _tmp0_;
	gint color_new = 0;
	gint color_old = 0;
	GeeArrayList* _tmp1_;
	gpointer _tmp2_;
	GSettings* _tmp3_;
	gint _tmp4_;
	GeeArrayList* _tmp24_;
	gpointer _tmp25_;
	GSettings* _tmp26_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (combo_box != NULL);
	_tmp0_ = self->priv->combo_boxes;
	id = gee_abstract_list_index_of ((GeeAbstractList*) _tmp0_, G_TYPE_CHECK_INSTANCE_CAST (combo_box, gtk_combo_box_text_get_type (), GtkComboBoxText));
	color_new = gtk_combo_box_get_active (combo_box);
	_tmp1_ = self->priv->worm_settings;
	_tmp2_ = gee_abstract_list_get ((GeeAbstractList*) _tmp1_, id);
	_tmp3_ = (GSettings*) _tmp2_;
	_tmp4_ = g_settings_get_enum (_tmp3_, "color");
	_g_object_unref0 (_tmp3_);
	color_old = _tmp4_;
	if (color_new == color_old) {
		return;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp7_ = FALSE;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = i;
					i = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				if (!(i < NIBBLES_GAME_MAX_WORMS)) {
					break;
				}
				if (i != id) {
					GeeArrayList* _tmp8_;
					gpointer _tmp9_;
					GSettings* _tmp10_;
					_tmp8_ = self->priv->worm_settings;
					_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, i);
					_tmp10_ = (GSettings*) _tmp9_;
					_tmp7_ = g_settings_get_enum (_tmp10_, "color") == color_new;
					_g_object_unref0 (_tmp10_);
				} else {
					_tmp7_ = FALSE;
				}
				if (_tmp7_) {
					GeeArrayList* _tmp11_;
					gpointer _tmp12_;
					GSettings* _tmp13_;
					_tmp11_ = self->priv->worm_settings;
					_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, i);
					_tmp13_ = (GSettings*) _tmp12_;
					g_settings_set_enum (_tmp13_, "color", color_old);
					_g_object_unref0 (_tmp13_);
					if (i < NIBBLES_GAME_MAX_HUMANS) {
						{
							GeeArrayList* _cbox_list = NULL;
							GeeArrayList* _tmp14_;
							GeeArrayList* _tmp15_;
							gint _cbox_size = 0;
							GeeArrayList* _tmp16_;
							gint _tmp17_;
							gint _tmp18_;
							gint _cbox_index = 0;
							_tmp14_ = self->priv->combo_boxes;
							_tmp15_ = _g_object_ref0 (_tmp14_);
							_cbox_list = _tmp15_;
							_tmp16_ = _cbox_list;
							_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
							_tmp18_ = _tmp17_;
							_cbox_size = _tmp18_;
							_cbox_index = -1;
							while (TRUE) {
								GtkComboBoxText* cbox = NULL;
								GeeArrayList* _tmp19_;
								gpointer _tmp20_;
								gint index = 0;
								GeeArrayList* _tmp21_;
								GtkComboBoxText* _tmp22_;
								_cbox_index = _cbox_index + 1;
								if (!(_cbox_index < _cbox_size)) {
									break;
								}
								_tmp19_ = _cbox_list;
								_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _cbox_index);
								cbox = (GtkComboBoxText*) _tmp20_;
								_tmp21_ = self->priv->combo_boxes;
								_tmp22_ = cbox;
								index = gee_abstract_list_index_of ((GeeAbstractList*) _tmp21_, _tmp22_);
								if (index == i) {
									GtkComboBoxText* _tmp23_;
									_tmp23_ = cbox;
									gtk_combo_box_set_active ((GtkComboBox*) _tmp23_, color_old);
									_g_object_unref0 (cbox);
									break;
								}
								_g_object_unref0 (cbox);
							}
							_g_object_unref0 (_cbox_list);
						}
					}
					break;
				}
			}
		}
	}
	_tmp24_ = self->priv->worm_settings;
	_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, id);
	_tmp26_ = (GSettings*) _tmp25_;
	g_settings_set_enum (_tmp26_, "color", color_new);
	_g_object_unref0 (_tmp26_);
}

static void
preferences_dialog_class_init (PreferencesDialogClass * klass,
                               gpointer klass_data)
{
	preferences_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PreferencesDialog_private_offset);
	G_OBJECT_CLASS (klass)->finalize = preferences_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/nibbles/ui/preferences-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "notebook", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, notebook));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "beginner_radio_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, beginner_radio_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "slow_radio_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, slow_radio_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "medium_radio_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, medium_radio_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fast_radio_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, fast_radio_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "sound_check_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, sound_check_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "fakes_check_button", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, fakes_check_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "list_store_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, list_store_4));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "tree_view_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, tree_view_4));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_1", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_1));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_2", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_2));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_3", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_3));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "combo_box_4", FALSE, PreferencesDialog_private_offset + G_STRUCT_OFFSET (PreferencesDialogPrivate, combo_box_4));
}

static void
preferences_dialog_instance_init (PreferencesDialog * self,
                                  gpointer klass)
{
	self->priv = preferences_dialog_get_instance_private (self);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
preferences_dialog_finalize (GObject * obj)
{
	PreferencesDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFERENCES_DIALOG, PreferencesDialog);
	_g_object_unref0 (self->priv->window);
	_g_object_unref0 (self->priv->settings);
	_g_object_unref0 (self->priv->worm_settings);
	_g_object_unref0 (self->priv->notebook);
	_g_object_unref0 (self->priv->beginner_radio_button);
	_g_object_unref0 (self->priv->slow_radio_button);
	_g_object_unref0 (self->priv->medium_radio_button);
	_g_object_unref0 (self->priv->fast_radio_button);
	_g_object_unref0 (self->priv->sound_check_button);
	_g_object_unref0 (self->priv->fakes_check_button);
	_g_object_unref0 (self->priv->list_store_1);
	_g_object_unref0 (self->priv->list_store_2);
	_g_object_unref0 (self->priv->list_store_3);
	_g_object_unref0 (self->priv->list_store_4);
	_g_object_unref0 (self->priv->tree_view_1);
	_g_object_unref0 (self->priv->tree_view_2);
	_g_object_unref0 (self->priv->tree_view_3);
	_g_object_unref0 (self->priv->tree_view_4);
	_g_object_unref0 (self->priv->combo_box_1);
	_g_object_unref0 (self->priv->combo_box_2);
	_g_object_unref0 (self->priv->combo_box_3);
	_g_object_unref0 (self->priv->combo_box_4);
	_g_object_unref0 (self->priv->radio_buttons);
	_g_object_unref0 (self->priv->list_stores);
	_g_object_unref0 (self->priv->tree_views);
	_g_object_unref0 (self->priv->combo_boxes);
	G_OBJECT_CLASS (preferences_dialog_parent_class)->finalize (obj);
}

GType
preferences_dialog_get_type (void)
{
	static volatile gsize preferences_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&preferences_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PreferencesDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) preferences_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreferencesDialog), 0, (GInstanceInitFunc) preferences_dialog_instance_init, NULL };
		GType preferences_dialog_type_id;
		preferences_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "PreferencesDialog", &g_define_type_info, 0);
		PreferencesDialog_private_offset = g_type_add_instance_private (preferences_dialog_type_id, sizeof (PreferencesDialogPrivate));
		g_once_init_leave (&preferences_dialog_type_id__volatile, preferences_dialog_type_id);
	}
	return preferences_dialog_type_id__volatile;
}

