/* worm.c generated by valac 0.46.1, the Vala compiler
 * generated from worm.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/* This is a fairly literal translation of the GPLv2+ original by*/
/* Sean MacIsaac, Ian Peters, Guillaume Béland.*/

#include <glib-object.h>
#include <glib.h>
#include <string.h>
#include <gee.h>

typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
typedef struct _WormProperties WormProperties;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;
typedef struct _WormPrivate WormPrivate;
enum  {
	WORM_0_PROPERTY,
	WORM_STARTING_POSITION_PROPERTY,
	WORM_ID_PROPERTY,
	WORM_IS_MATERIALIZED_PROPERTY,
	WORM_LIVES_PROPERTY,
	WORM_SCORE_PROPERTY,
	WORM_LENGTH_PROPERTY,
	WORM_HEAD_PROPERTY,
	WORM_LIST_PROPERTY,
	WORM_NUM_PROPERTIES
};
static GParamSpec* worm_properties[WORM_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _position_free0(var) ((var == NULL) ? NULL : (var = (position_free (var), NULL)))

#define TYPE_WARP (warp_get_type ())
#define WARP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP, Warp))
#define WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP, WarpClass))
#define IS_WARP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP))
#define IS_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP))
#define WARP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP, WarpClass))

typedef struct _Warp Warp;
typedef struct _WarpClass WarpClass;
typedef struct _WarpPrivate WarpPrivate;
#define _worm_properties_free0(var) ((var == NULL) ? NULL : (var = (worm_properties_free (var), NULL)))
typedef enum  {
	BONUS_TYPE_REGULAR,
	BONUS_TYPE_HALF,
	BONUS_TYPE_DOUBLE,
	BONUS_TYPE_LIFE,
	BONUS_TYPE_REVERSE,
	BONUS_TYPE_WARP
} BonusType;

#define TYPE_BONUS_TYPE (bonus_type_get_type ())
enum  {
	WORM_ADDED_SIGNAL,
	WORM_FINISH_ADDED_SIGNAL,
	WORM_MOVED_SIGNAL,
	WORM_RESCALED_SIGNAL,
	WORM_DIED_SIGNAL,
	WORM_TAIL_REDUCED_SIGNAL,
	WORM_REVERSED_SIGNAL,
	WORM_BONUS_FOUND_SIGNAL,
	WORM_WARP_FOUND_SIGNAL,
	WORM_NUM_SIGNALS
};
static guint worm_signals[WORM_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Position {
	gint x;
	gint y;
};

struct _WormProperties {
	gint color;
	guint up;
	guint down;
	guint left;
	guint right;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gboolean keypress;
	gboolean is_stopped;
	gint change;
	WormDirection direction;
	WormDirection starting_direction;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _WormPrivate {
	Position _starting_position;
	gint _id;
	gboolean _is_materialized;
	gint rounds_dematerialized;
	gint _lives;
	gint _score;
	GeeArrayQueue* key_queue;
	GeeLinkedList* _list;
};

struct _Warp {
	GObject parent_instance;
	WarpPrivate * priv;
	gint x;
	gint y;
	gint wx;
	gint wy;
};

struct _WarpClass {
	GObjectClass parent_class;
};

static gint Worm_private_offset;
static gpointer worm_parent_class = NULL;
static guint* worm_deadend_board;
static gint worm_deadend_board_length1;
static gint worm_deadend_board_length2;
static guint* worm_deadend_board = NULL;
static gint worm_deadend_board_length1 = 0;
static gint worm_deadend_board_length2 = 0;
static guint worm_deadend_runnumber;
static guint worm_deadend_runnumber = (guint) 0;

GType worm_direction_get_type (void) G_GNUC_CONST;
GType position_get_type (void) G_GNUC_CONST;
Position* position_dup (const Position* self);
void position_free (Position* self);
GType worm_properties_get_type (void) G_GNUC_CONST;
WormProperties* worm_properties_dup (const WormProperties* self);
void worm_properties_free (WormProperties* self);
GType worm_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
#define NIBBLES_GAME_WIDTH 92
#define NIBBLES_GAME_HEIGHT 66
#define WORM_STARTING_LENGTH 5
#define WORM_STARTING_LIVES 6
#define WORM_MAX_LIVES 12
#define WORM_GROW_FACTOR 4
Worm* worm_new (gint id);
Worm* worm_construct (GType object_type,
                      gint id);
static void worm_set_id (Worm* self,
                  gint value);
void worm_set_lives (Worm* self,
                     gint value);
void worm_set_score (Worm* self,
                     gint value);
static void worm_set_list (Worm* self,
                    GeeLinkedList* value);
void worm_set_start (Worm* self,
                     gint xhead,
                     gint yhead,
                     WormDirection direction);
GeeLinkedList* worm_get_list (Worm* self);
static void worm_set_starting_position (Worm* self,
                                 Position * value);
void worm_get_starting_position (Worm* self,
                                 Position * result);
void worm_move (Worm* self,
                gint* board,
                gint board_length1,
                gint board_length2);
void worm_get_head (Worm* self,
                    Position * result);
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_EMPTYCHAR 'a'
gboolean worm_get_is_materialized (Worm* self);
#define NIBBLES_GAME_WORMCHAR 'w'
gint worm_get_id (Worm* self);
void worm_dequeue_keypress (Worm* self);
static void worm_materialize (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2);
void worm_reduce_tail (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       gint erase_size);
void worm_reverse (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2);
GType warp_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Warp, g_object_unref)
void worm_warp (Worm* self,
                Warp* warp);
static void worm_set_head (Worm* self,
                    Position * value);
gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           gint numworms);
static void worm_position_move (Worm* self,
                         Position* result);
gboolean worm_will_collide_with_head (Worm* self,
                                      Worm* other_worm);
static gboolean _position_equal (const Position * s1,
                          const Position * s2);
void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void worm_set_is_materialized (Worm* self,
                               gboolean value);
void worm_dematerialize (Worm* self,
                         gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint rounds);
void worm_add_life (Worm* self);
gint worm_get_lives (Worm* self);
static void worm_lose_life (Worm* self);
void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void worm_direction_set (Worm* self,
                         WormDirection dir);
void worm_queue_keypress (Worm* self,
                          WormDirection dir);
static guint worm_upper_key (Worm* self,
                      guint keyval);
void worm_handle_direction (Worm* self,
                            WormDirection dir);
gboolean worm_handle_keypress (Worm* self,
                               guint keyval,
                               GeeHashMap* worm_props);
static gint worm_ai_deadend (gint* board,
                      gint board_length1,
                      gint board_length2,
                      gint numworms,
                      gint x,
                      gint y,
                      gint length_left);
static gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            gint numworms,
                            gint x,
                            gint y,
                            gint dir,
                            gint length);
static gboolean worm_ai_too_close (Worm* self,
                            GeeLinkedList* worms,
                            gint numworms);
static gboolean worm_ai_wander (gint* board,
                         gint board_length1,
                         gint board_length2,
                         gint numworms,
                         gint x,
                         gint y,
                         gint dir,
                         gint ox,
                         gint oy);
GType bonus_type_get_type (void) G_GNUC_CONST;
void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   gint numworms,
                   GeeLinkedList* worms);
#define NIBBLES_GAME_CAPACITY (NIBBLES_GAME_WIDTH * NIBBLES_GAME_HEIGHT)
gint worm_get_length (Worm* self);
gint worm_get_score (Worm* self);
void worm_set_length (Worm* self,
                      gint value);
static void worm_finalize (GObject * obj);
static void _vala_worm_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_worm_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);

GType
worm_direction_get_type (void)
{
	static volatile gsize worm_direction_type_id__volatile = 0;
	if (g_once_init_enter (&worm_direction_type_id__volatile)) {
		static const GEnumValue values[] = {{WORM_DIRECTION_NONE, "WORM_DIRECTION_NONE", "none"}, {WORM_DIRECTION_RIGHT, "WORM_DIRECTION_RIGHT", "right"}, {WORM_DIRECTION_DOWN, "WORM_DIRECTION_DOWN", "down"}, {WORM_DIRECTION_LEFT, "WORM_DIRECTION_LEFT", "left"}, {WORM_DIRECTION_UP, "WORM_DIRECTION_UP", "up"}, {0, NULL, NULL}};
		GType worm_direction_type_id;
		worm_direction_type_id = g_enum_register_static ("WormDirection", values);
		g_once_init_leave (&worm_direction_type_id__volatile, worm_direction_type_id);
	}
	return worm_direction_type_id__volatile;
}

Position*
position_dup (const Position* self)
{
	Position* dup;
	dup = g_new0 (Position, 1);
	memcpy (dup, self, sizeof (Position));
	return dup;
}

void
position_free (Position* self)
{
	g_free (self);
}

GType
position_get_type (void)
{
	static volatile gsize position_type_id__volatile = 0;
	if (g_once_init_enter (&position_type_id__volatile)) {
		GType position_type_id;
		position_type_id = g_boxed_type_register_static ("Position", (GBoxedCopyFunc) position_dup, (GBoxedFreeFunc) position_free);
		g_once_init_leave (&position_type_id__volatile, position_type_id);
	}
	return position_type_id__volatile;
}

WormProperties*
worm_properties_dup (const WormProperties* self)
{
	WormProperties* dup;
	dup = g_new0 (WormProperties, 1);
	memcpy (dup, self, sizeof (WormProperties));
	return dup;
}

void
worm_properties_free (WormProperties* self)
{
	g_free (self);
}

GType
worm_properties_get_type (void)
{
	static volatile gsize worm_properties_type_id__volatile = 0;
	if (g_once_init_enter (&worm_properties_type_id__volatile)) {
		GType worm_properties_type_id;
		worm_properties_type_id = g_boxed_type_register_static ("WormProperties", (GBoxedCopyFunc) worm_properties_dup, (GBoxedFreeFunc) worm_properties_free);
		g_once_init_leave (&worm_properties_type_id__volatile, worm_properties_type_id);
	}
	return worm_properties_type_id__volatile;
}

static inline gpointer
worm_get_instance_private (Worm* self)
{
	return G_STRUCT_MEMBER_P (self, Worm_private_offset);
}

Worm*
worm_construct (GType object_type,
                gint id)
{
	Worm * self = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeArrayQueue* _tmp2_;
	self = (Worm*) g_object_new (object_type, NULL);
	worm_set_id (self, id);
	worm_set_lives (self, WORM_STARTING_LIVES);
	worm_set_score (self, 0);
	self->change = 0;
	_tmp0_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
	_tmp1_ = _tmp0_;
	worm_set_list (self, _tmp1_);
	_g_object_unref0 (_tmp1_);
	_tmp2_ = gee_array_queue_new (TYPE_WORM_DIRECTION, NULL, NULL, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->key_queue);
	self->priv->key_queue = _tmp2_;
	return self;
}

Worm*
worm_new (gint id)
{
	return worm_construct (TYPE_WORM, id);
}

void
worm_set_start (Worm* self,
                gint xhead,
                gint yhead,
                WormDirection direction)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_ = {0};
	GeeLinkedList* _tmp2_;
	Position _tmp3_;
	WormDirection _tmp4_;
	GeeArrayQueue* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	memset (&_tmp1_, 0, sizeof (Position));
	_tmp1_.x = xhead;
	_tmp1_.y = yhead;
	worm_set_starting_position (self, &_tmp1_);
	_tmp2_ = self->priv->_list;
	_tmp3_ = self->priv->_starting_position;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp2_, &_tmp3_);
	self->starting_direction = direction;
	_tmp4_ = self->starting_direction;
	self->direction = _tmp4_;
	self->change = 0;
	_tmp5_ = self->priv->key_queue;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp5_);
}

void
worm_move (Worm* self,
           gint* board,
           gint board_length1,
           gint board_length2)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	GeeLinkedList* _tmp23_;
	Position _tmp24_;
	Position _tmp25_ = {0};
	Position _tmp26_;
	Position _tmp27_ = {0};
	Position _tmp28_;
	gint _tmp29_;
	Position _tmp40_ = {0};
	Position _tmp41_;
	Position _tmp42_ = {0};
	Position _tmp43_;
	gint _tmp44_;
	gboolean _tmp45_;
	GeeArrayQueue* _tmp51_;
	gboolean _tmp52_;
	gboolean _tmp53_;
	g_return_if_fail (self != NULL);
	if (self->is_human) {
		self->keypress = FALSE;
	}
	worm_get_head (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	position = _tmp1_;
	_tmp2_ = self->direction;
	switch (_tmp2_) {
		case WORM_DIRECTION_UP:
		{
			Position _tmp3_ = {0};
			Position _tmp4_;
			Position _tmp5_ = {0};
			Position _tmp6_;
			Position _tmp7_;
			worm_get_head (self, &_tmp3_);
			_tmp4_ = _tmp3_;
			worm_get_head (self, &_tmp5_);
			_tmp6_ = _tmp5_;
			_tmp6_.y = _tmp6_.y - 1;
			position.y = _tmp6_.y;
			_tmp7_ = position;
			if (_tmp7_.y < 0) {
				position.y = NIBBLES_GAME_HEIGHT - 1;
			}
			break;
		}
		case WORM_DIRECTION_DOWN:
		{
			Position _tmp8_ = {0};
			Position _tmp9_;
			Position _tmp10_ = {0};
			Position _tmp11_;
			Position _tmp12_;
			worm_get_head (self, &_tmp8_);
			_tmp9_ = _tmp8_;
			worm_get_head (self, &_tmp10_);
			_tmp11_ = _tmp10_;
			_tmp11_.y = _tmp11_.y + 1;
			position.y = _tmp11_.y;
			_tmp12_ = position;
			if (_tmp12_.y >= NIBBLES_GAME_HEIGHT) {
				position.y = 0;
			}
			break;
		}
		case WORM_DIRECTION_LEFT:
		{
			Position _tmp13_ = {0};
			Position _tmp14_;
			Position _tmp15_ = {0};
			Position _tmp16_;
			Position _tmp17_;
			worm_get_head (self, &_tmp13_);
			_tmp14_ = _tmp13_;
			worm_get_head (self, &_tmp15_);
			_tmp16_ = _tmp15_;
			_tmp16_.x = _tmp16_.x - 1;
			position.x = _tmp16_.x;
			_tmp17_ = position;
			if (_tmp17_.x < 0) {
				position.x = NIBBLES_GAME_WIDTH - 1;
			}
			break;
		}
		case WORM_DIRECTION_RIGHT:
		{
			Position _tmp18_ = {0};
			Position _tmp19_;
			Position _tmp20_ = {0};
			Position _tmp21_;
			Position _tmp22_;
			worm_get_head (self, &_tmp18_);
			_tmp19_ = _tmp18_;
			worm_get_head (self, &_tmp20_);
			_tmp21_ = _tmp20_;
			_tmp21_.x = _tmp21_.x + 1;
			position.x = _tmp21_.x;
			_tmp22_ = position;
			if (_tmp22_.x >= NIBBLES_GAME_WIDTH) {
				position.x = 0;
			}
			break;
		}
		default:
		{
			break;
		}
	}
	_tmp23_ = self->priv->_list;
	_tmp24_ = position;
	gee_deque_offer_head ((GeeDeque*) _tmp23_, &_tmp24_);
	worm_get_head (self, &_tmp25_);
	_tmp26_ = _tmp25_;
	worm_get_head (self, &_tmp27_);
	_tmp28_ = _tmp27_;
	_tmp29_ = board[(_tmp26_.x * board_length2) + _tmp28_.y];
	if (_tmp29_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
		g_signal_emit (self, worm_signals[WORM_WARP_FOUND_SIGNAL], 0);
	}
	if (self->change > 0) {
		gint _tmp30_;
		_tmp30_ = self->change;
		self->change = _tmp30_ - 1;
		g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
	} else {
		GeeLinkedList* _tmp31_;
		gpointer _tmp32_;
		Position* _tmp33_;
		GeeLinkedList* _tmp34_;
		gpointer _tmp35_;
		Position* _tmp36_;
		GeeLinkedList* _tmp37_;
		gpointer _tmp38_;
		Position* _tmp39_;
		_tmp31_ = self->priv->_list;
		_tmp32_ = gee_linked_list_last (_tmp31_);
		_tmp33_ = (Position*) _tmp32_;
		_tmp34_ = self->priv->_list;
		_tmp35_ = gee_linked_list_last (_tmp34_);
		_tmp36_ = (Position*) _tmp35_;
		board[((*_tmp33_).x * board_length2) + (*_tmp36_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
		_position_free0 (_tmp36_);
		_position_free0 (_tmp33_);
		_tmp37_ = self->priv->_list;
		_tmp38_ = gee_deque_poll_tail ((GeeDeque*) _tmp37_);
		_tmp39_ = (Position*) _tmp38_;
		_position_free0 (_tmp39_);
		g_signal_emit (self, worm_signals[WORM_MOVED_SIGNAL], 0);
	}
	worm_get_head (self, &_tmp40_);
	_tmp41_ = _tmp40_;
	worm_get_head (self, &_tmp42_);
	_tmp43_ = _tmp42_;
	_tmp44_ = board[(_tmp41_.x * board_length2) + _tmp43_.y];
	if (_tmp44_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
		g_signal_emit (self, worm_signals[WORM_BONUS_FOUND_SIGNAL], 0);
	}
	_tmp45_ = self->priv->_is_materialized;
	if (_tmp45_) {
		Position _tmp46_ = {0};
		Position _tmp47_;
		Position _tmp48_ = {0};
		Position _tmp49_;
		gint _tmp50_;
		worm_get_head (self, &_tmp46_);
		_tmp47_ = _tmp46_;
		worm_get_head (self, &_tmp48_);
		_tmp49_ = _tmp48_;
		_tmp50_ = self->priv->_id;
		board[(_tmp47_.x * board_length2) + _tmp49_.y] = NIBBLES_GAME_WORMCHAR + _tmp50_;
	} else {
		self->priv->rounds_dematerialized = self->priv->rounds_dematerialized - 1;
	}
	_tmp51_ = self->priv->key_queue;
	_tmp52_ = gee_array_queue_get_is_empty (_tmp51_);
	_tmp53_ = _tmp52_;
	if (!_tmp53_) {
		worm_dequeue_keypress (self);
	}
	if (self->priv->rounds_dematerialized == 1) {
		worm_materialize (self, board, (gint) board_length1, (gint) board_length2);
	}
}

void
worm_reduce_tail (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint erase_size)
{
	g_return_if_fail (self != NULL);
	if (erase_size > 0) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp0_ = FALSE;
				_tmp0_ = TRUE;
				while (TRUE) {
					GeeLinkedList* _tmp2_;
					gpointer _tmp3_;
					Position* _tmp4_;
					GeeLinkedList* _tmp5_;
					gpointer _tmp6_;
					Position* _tmp7_;
					GeeLinkedList* _tmp8_;
					gpointer _tmp9_;
					Position* _tmp10_;
					if (!_tmp0_) {
						gint _tmp1_;
						_tmp1_ = i;
						i = _tmp1_ + 1;
					}
					_tmp0_ = FALSE;
					if (!(i < erase_size)) {
						break;
					}
					_tmp2_ = self->priv->_list;
					_tmp3_ = gee_linked_list_last (_tmp2_);
					_tmp4_ = (Position*) _tmp3_;
					_tmp5_ = self->priv->_list;
					_tmp6_ = gee_linked_list_last (_tmp5_);
					_tmp7_ = (Position*) _tmp6_;
					board[((*_tmp4_).x * board_length2) + (*_tmp7_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
					_position_free0 (_tmp7_);
					_position_free0 (_tmp4_);
					_tmp8_ = self->priv->_list;
					_tmp9_ = gee_deque_poll_tail ((GeeDeque*) _tmp8_);
					_tmp10_ = (Position*) _tmp9_;
					_position_free0 (_tmp10_);
				}
			}
		}
		g_signal_emit (self, worm_signals[WORM_TAIL_REDUCED_SIGNAL], 0, erase_size);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
worm_reverse (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2)
{
	GeeLinkedList* reversed_list = NULL;
	GeeLinkedList* _tmp0_;
	GeeLinkedList* _tmp10_;
	GeeLinkedList* _tmp11_;
	gpointer _tmp12_;
	Position* _tmp13_;
	GeeLinkedList* _tmp14_;
	gpointer _tmp15_;
	Position* _tmp16_;
	gboolean _tmp17_;
	g_return_if_fail (self != NULL);
	_tmp0_ = gee_linked_list_new (TYPE_POSITION, (GBoxedCopyFunc) position_dup, (GDestroyNotify) position_free, NULL, NULL, NULL);
	reversed_list = _tmp0_;
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _pos_index = 0;
		_tmp1_ = self->priv->_list;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_pos_list = _tmp2_;
		_tmp3_ = _pos_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_pos_size = _tmp5_;
		_pos_index = -1;
		while (TRUE) {
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			GeeLinkedList* _tmp8_;
			Position* _tmp9_;
			_pos_index = _pos_index + 1;
			if (!(_pos_index < _pos_size)) {
				break;
			}
			_tmp6_ = _pos_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
			pos = (Position*) _tmp7_;
			_tmp8_ = reversed_list;
			_tmp9_ = pos;
			gee_deque_offer_head ((GeeDeque*) _tmp8_, _tmp9_);
			_position_free0 (pos);
		}
		_g_object_unref0 (_pos_list);
	}
	g_signal_emit (self, worm_signals[WORM_REVERSED_SIGNAL], 0);
	_tmp10_ = reversed_list;
	worm_set_list (self, _tmp10_);
	_tmp11_ = self->priv->_list;
	_tmp12_ = gee_abstract_list_get ((GeeAbstractList*) _tmp11_, 0);
	_tmp13_ = (Position*) _tmp12_;
	_tmp14_ = self->priv->_list;
	_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, 1);
	_tmp16_ = (Position*) _tmp15_;
	_tmp17_ = (*_tmp13_).y == (*_tmp16_).y;
	_position_free0 (_tmp16_);
	_position_free0 (_tmp13_);
	if (_tmp17_) {
		WormDirection _tmp18_ = 0;
		GeeLinkedList* _tmp19_;
		gpointer _tmp20_;
		Position* _tmp21_;
		GeeLinkedList* _tmp22_;
		gpointer _tmp23_;
		Position* _tmp24_;
		gboolean _tmp25_;
		_tmp19_ = self->priv->_list;
		_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, 0);
		_tmp21_ = (Position*) _tmp20_;
		_tmp22_ = self->priv->_list;
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 1);
		_tmp24_ = (Position*) _tmp23_;
		_tmp25_ = (*_tmp21_).x > (*_tmp24_).x;
		_position_free0 (_tmp24_);
		_position_free0 (_tmp21_);
		if (_tmp25_) {
			_tmp18_ = WORM_DIRECTION_RIGHT;
		} else {
			_tmp18_ = WORM_DIRECTION_LEFT;
		}
		self->direction = _tmp18_;
	} else {
		WormDirection _tmp26_ = 0;
		GeeLinkedList* _tmp27_;
		gpointer _tmp28_;
		Position* _tmp29_;
		GeeLinkedList* _tmp30_;
		gpointer _tmp31_;
		Position* _tmp32_;
		gboolean _tmp33_;
		_tmp27_ = self->priv->_list;
		_tmp28_ = gee_abstract_list_get ((GeeAbstractList*) _tmp27_, 0);
		_tmp29_ = (Position*) _tmp28_;
		_tmp30_ = self->priv->_list;
		_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, 1);
		_tmp32_ = (Position*) _tmp31_;
		_tmp33_ = (*_tmp29_).y > (*_tmp32_).y;
		_position_free0 (_tmp32_);
		_position_free0 (_tmp29_);
		if (_tmp33_) {
			_tmp26_ = WORM_DIRECTION_DOWN;
		} else {
			_tmp26_ = WORM_DIRECTION_UP;
		}
		self->direction = _tmp26_;
	}
	_g_object_unref0 (reversed_list);
}

void
worm_warp (Worm* self,
           Warp* warp)
{
	Position _tmp0_ = {0};
	g_return_if_fail (self != NULL);
	g_return_if_fail (warp != NULL);
	memset (&_tmp0_, 0, sizeof (Position));
	_tmp0_.x = warp->wx;
	_tmp0_.y = warp->wy;
	worm_set_head (self, &_tmp0_);
}

gboolean
worm_can_move_to (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2,
                  gint numworms)
{
	Position position = {0};
	Position _tmp0_ = {0};
	gint next_position = 0;
	Position _tmp1_;
	Position _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	worm_position_move (self, &_tmp0_);
	position = _tmp0_;
	_tmp1_ = position;
	_tmp2_ = position;
	_tmp3_ = board[(_tmp1_.x * board_length2) + _tmp2_.y];
	next_position = _tmp3_;
	if (next_position > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
		_tmp4_ = next_position < ((gint) NIBBLES_GAME_WORMCHAR);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		result = FALSE;
		return result;
	}
	if (next_position >= ((gint) NIBBLES_GAME_WORMCHAR)) {
		_tmp5_ = next_position < (NIBBLES_GAME_WORMCHAR + numworms);
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		gboolean _tmp6_;
		_tmp6_ = self->priv->_is_materialized;
		result = !_tmp6_;
		return result;
	}
	result = TRUE;
	return result;
}

static gboolean
_position_equal (const Position * s1,
                 const Position * s2)
{
	if (s1 == s2) {
		return TRUE;
	}
	if (s1 == NULL) {
		return FALSE;
	}
	if (s2 == NULL) {
		return FALSE;
	}
	if (s1->x != s2->x) {
		return FALSE;
	}
	if (s1->y != s2->y) {
		return FALSE;
	}
	return TRUE;
}

gboolean
worm_will_collide_with_head (Worm* self,
                             Worm* other_worm)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	Position worm_pos = {0};
	Position _tmp3_ = {0};
	Position other_worm_pos = {0};
	Position _tmp4_ = {0};
	Position _tmp5_;
	Position _tmp6_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (other_worm != NULL, FALSE);
	_tmp1_ = self->priv->_is_materialized;
	if (!_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp2_;
		_tmp2_ = other_worm->priv->_is_materialized;
		_tmp0_ = !_tmp2_;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	worm_position_move (self, &_tmp3_);
	worm_pos = _tmp3_;
	worm_position_move (other_worm, &_tmp4_);
	other_worm_pos = _tmp4_;
	_tmp5_ = worm_pos;
	_tmp6_ = other_worm_pos;
	if (_position_equal (&_tmp5_, &_tmp6_) == TRUE) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

void
worm_spawn (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	g_return_if_fail (self != NULL);
	self->change = WORM_STARTING_LENGTH - 1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < WORM_STARTING_LENGTH)) {
					break;
				}
				worm_move (self, board, (gint) board_length1, (gint) board_length2);
			}
		}
	}
}

static void
worm_materialize (Worm* self,
                  gint* board,
                  gint board_length1,
                  gint board_length2)
{
	g_return_if_fail (self != NULL);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
		_tmp0_ = self->priv->_list;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_pos_list = _tmp1_;
		_tmp2_ = _pos_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_pos_size = _tmp4_;
		_pos_index = -1;
		while (TRUE) {
			Position* pos = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			Position* _tmp7_;
			Position* _tmp8_;
			gint _tmp9_;
			_pos_index = _pos_index + 1;
			if (!(_pos_index < _pos_size)) {
				break;
			}
			_tmp5_ = _pos_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _pos_index);
			pos = (Position*) _tmp6_;
			_tmp7_ = pos;
			_tmp8_ = pos;
			_tmp9_ = board[((*_tmp7_).x * board_length2) + (*_tmp8_).y];
			if (_tmp9_ != ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				self->priv->rounds_dematerialized = self->priv->rounds_dematerialized + 1;
				_position_free0 (pos);
				_g_object_unref0 (_pos_list);
				return;
			}
			_position_free0 (pos);
		}
		_g_object_unref0 (_pos_list);
	}
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp10_;
		GeeLinkedList* _tmp11_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp12_;
		gint _tmp13_;
		gint _tmp14_;
		gint _pos_index = 0;
		_tmp10_ = self->priv->_list;
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_pos_list = _tmp11_;
		_tmp12_ = _pos_list;
		_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
		_tmp14_ = _tmp13_;
		_pos_size = _tmp14_;
		_pos_index = -1;
		while (TRUE) {
			Position* pos = NULL;
			GeeLinkedList* _tmp15_;
			gpointer _tmp16_;
			Position* _tmp17_;
			Position* _tmp18_;
			gint _tmp19_;
			_pos_index = _pos_index + 1;
			if (!(_pos_index < _pos_size)) {
				break;
			}
			_tmp15_ = _pos_list;
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _pos_index);
			pos = (Position*) _tmp16_;
			_tmp17_ = pos;
			_tmp18_ = pos;
			_tmp19_ = self->priv->_id;
			board[((*_tmp17_).x * board_length2) + (*_tmp18_).y] = NIBBLES_GAME_WORMCHAR + _tmp19_;
			_position_free0 (pos);
		}
		_g_object_unref0 (_pos_list);
	}
	worm_set_is_materialized (self, TRUE);
	self->priv->rounds_dematerialized = 0;
}

void
worm_dematerialize (Worm* self,
                    gint* board,
                    gint board_length1,
                    gint board_length2,
                    gint rounds)
{
	g_return_if_fail (self != NULL);
	self->priv->rounds_dematerialized = rounds;
	worm_set_is_materialized (self, FALSE);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _pos_index = 0;
		_tmp0_ = self->priv->_list;
		_tmp1_ = _g_object_ref0 (_tmp0_);
		_pos_list = _tmp1_;
		_tmp2_ = _pos_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_pos_size = _tmp4_;
		_pos_index = -1;
		while (TRUE) {
			Position* pos = NULL;
			GeeLinkedList* _tmp5_;
			gpointer _tmp6_;
			Position* _tmp7_;
			Position* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			_pos_index = _pos_index + 1;
			if (!(_pos_index < _pos_size)) {
				break;
			}
			_tmp5_ = _pos_list;
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _pos_index);
			pos = (Position*) _tmp6_;
			_tmp7_ = pos;
			_tmp8_ = pos;
			_tmp9_ = board[((*_tmp7_).x * board_length2) + (*_tmp8_).y];
			_tmp10_ = self->priv->_id;
			if (_tmp9_ == (NIBBLES_GAME_WORMCHAR + _tmp10_)) {
				Position* _tmp11_;
				Position* _tmp12_;
				_tmp11_ = pos;
				_tmp12_ = pos;
				board[((*_tmp11_).x * board_length2) + (*_tmp12_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
			}
			_position_free0 (pos);
		}
		_g_object_unref0 (_pos_list);
	}
}

void
worm_add_life (Worm* self)
{
	gint _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_lives;
	if (_tmp0_ > WORM_MAX_LIVES) {
		return;
	}
	_tmp1_ = self->priv->_lives;
	worm_set_lives (self, _tmp1_ + 1);
}

static void
worm_lose_life (Worm* self)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_lives;
	worm_set_lives (self, _tmp0_ - 1);
}

void
worm_reset (Worm* self,
            gint* board,
            gint board_length1,
            gint board_length2)
{
	GeeArrayQueue* _tmp0_;
	GeeLinkedList* _tmp10_;
	GeeLinkedList* _tmp11_;
	Position _tmp12_;
	WormDirection _tmp13_;
	g_return_if_fail (self != NULL);
	self->is_stopped = TRUE;
	worm_set_is_materialized (self, FALSE);
	self->priv->rounds_dematerialized = 0;
	_tmp0_ = self->priv->key_queue;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
	worm_lose_life (self);
	g_signal_emit (self, worm_signals[WORM_DIED_SIGNAL], 0);
	{
		GeeLinkedList* _pos_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _pos_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _pos_index = 0;
		_tmp1_ = self->priv->_list;
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_pos_list = _tmp2_;
		_tmp3_ = _pos_list;
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
		_tmp5_ = _tmp4_;
		_pos_size = _tmp5_;
		_pos_index = -1;
		while (TRUE) {
			Position* pos = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Position* _tmp8_;
			Position* _tmp9_;
			_pos_index = _pos_index + 1;
			if (!(_pos_index < _pos_size)) {
				break;
			}
			_tmp6_ = _pos_list;
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _pos_index);
			pos = (Position*) _tmp7_;
			_tmp8_ = pos;
			_tmp9_ = pos;
			board[((*_tmp8_).x * board_length2) + (*_tmp9_).y] = (gint) NIBBLES_GAME_EMPTYCHAR;
			_position_free0 (pos);
		}
		_g_object_unref0 (_pos_list);
	}
	_tmp10_ = self->priv->_list;
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp10_);
	_tmp11_ = self->priv->_list;
	_tmp12_ = self->priv->_starting_position;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp11_, &_tmp12_);
	g_signal_emit (self, worm_signals[WORM_ADDED_SIGNAL], 0);
	_tmp13_ = self->starting_direction;
	self->direction = _tmp13_;
	self->change = 0;
	worm_spawn (self, board, (gint) board_length1, (gint) board_length2);
	g_signal_emit (self, worm_signals[WORM_FINISH_ADDED_SIGNAL], 0);
}

static void
worm_position_move (Worm* self,
                    Position* result)
{
	Position position = {0};
	Position _tmp0_ = {0};
	Position _tmp1_;
	WormDirection _tmp2_;
	g_return_if_fail (self != NULL);
	worm_get_head (self, &_tmp0_);
	_tmp1_ = _tmp0_;
	position = _tmp1_;
	_tmp2_ = self->direction;
	switch (_tmp2_) {
		case WORM_DIRECTION_UP:
		{
			Position _tmp3_ = {0};
			Position _tmp4_;
			Position _tmp5_ = {0};
			Position _tmp6_;
			Position _tmp7_;
			worm_get_head (self, &_tmp3_);
			_tmp4_ = _tmp3_;
			worm_get_head (self, &_tmp5_);
			_tmp6_ = _tmp5_;
			_tmp6_.y = _tmp6_.y - 1;
			position.y = _tmp6_.y;
			_tmp7_ = position;
			if (_tmp7_.y < 0) {
				position.y = NIBBLES_GAME_HEIGHT - 1;
			}
			break;
		}
		case WORM_DIRECTION_DOWN:
		{
			Position _tmp8_ = {0};
			Position _tmp9_;
			Position _tmp10_ = {0};
			Position _tmp11_;
			Position _tmp12_;
			worm_get_head (self, &_tmp8_);
			_tmp9_ = _tmp8_;
			worm_get_head (self, &_tmp10_);
			_tmp11_ = _tmp10_;
			_tmp11_.y = _tmp11_.y + 1;
			position.y = _tmp11_.y;
			_tmp12_ = position;
			if (_tmp12_.y >= NIBBLES_GAME_HEIGHT) {
				position.y = 0;
			}
			break;
		}
		case WORM_DIRECTION_LEFT:
		{
			Position _tmp13_ = {0};
			Position _tmp14_;
			Position _tmp15_ = {0};
			Position _tmp16_;
			Position _tmp17_;
			worm_get_head (self, &_tmp13_);
			_tmp14_ = _tmp13_;
			worm_get_head (self, &_tmp15_);
			_tmp16_ = _tmp15_;
			_tmp16_.x = _tmp16_.x - 1;
			position.x = _tmp16_.x;
			_tmp17_ = position;
			if (_tmp17_.x < 0) {
				position.x = NIBBLES_GAME_WIDTH - 1;
			}
			break;
		}
		case WORM_DIRECTION_RIGHT:
		{
			Position _tmp18_ = {0};
			Position _tmp19_;
			Position _tmp20_ = {0};
			Position _tmp21_;
			Position _tmp22_;
			worm_get_head (self, &_tmp18_);
			_tmp19_ = _tmp18_;
			worm_get_head (self, &_tmp20_);
			_tmp21_ = _tmp20_;
			_tmp21_.x = _tmp21_.x + 1;
			position.x = _tmp21_.x;
			_tmp22_ = position;
			if (_tmp22_.x >= NIBBLES_GAME_WIDTH) {
				position.x = 0;
			}
			break;
		}
		default:
		{
			break;
		}
	}
	*result = position;
	return;
}

static void
worm_direction_set (Worm* self,
                    WormDirection dir)
{
	g_return_if_fail (self != NULL);
	if (!self->is_human) {
		return;
	}
	if (dir > 4) {
		dir = (WormDirection) 1;
	}
	if (dir < 1) {
		dir = (WormDirection) 4;
	}
	if (self->keypress) {
		worm_queue_keypress (self, dir);
		return;
	}
	self->direction = (WormDirection) dir;
	self->keypress = TRUE;
}

static guint
worm_upper_key (Worm* self,
                guint keyval)
{
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	if (keyval > ((guint) 255)) {
		result = keyval;
		return result;
	}
	result = (guint) g_ascii_toupper ((gchar) keyval);
	return result;
}

void
worm_handle_direction (Worm* self,
                       WormDirection dir)
{
	g_return_if_fail (self != NULL);
	worm_direction_set (self, dir);
}

gboolean
worm_handle_keypress (Worm* self,
                      guint keyval,
                      GeeHashMap* worm_props)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	WormProperties properties = {0};
	guint propsUp = 0U;
	guint propsDown = 0U;
	guint propsLeft = 0U;
	guint propsRight = 0U;
	guint keyvalUpper = 0U;
	gpointer _tmp2_;
	WormProperties* _tmp3_;
	WormProperties _tmp4_;
	WormProperties _tmp5_;
	WormProperties _tmp6_;
	WormProperties _tmp7_;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (worm_props != NULL, FALSE);
	_tmp1_ = self->priv->_lives;
	if (_tmp1_ <= 0) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->is_stopped;
	}
	if (_tmp0_) {
		result = FALSE;
		return result;
	}
	_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) worm_props, self);
	_tmp3_ = (WormProperties*) _tmp2_;
	properties = *_tmp3_;
	_worm_properties_free0 (_tmp3_);
	_tmp4_ = properties;
	propsUp = worm_upper_key (self, _tmp4_.up);
	_tmp5_ = properties;
	propsLeft = worm_upper_key (self, _tmp5_.left);
	_tmp6_ = properties;
	propsDown = worm_upper_key (self, _tmp6_.down);
	_tmp7_ = properties;
	propsRight = worm_upper_key (self, _tmp7_.right);
	keyvalUpper = worm_upper_key (self, keyval);
	if (keyvalUpper == propsUp) {
		WormDirection _tmp9_;
		_tmp9_ = self->direction;
		_tmp8_ = _tmp9_ != WORM_DIRECTION_DOWN;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		worm_handle_direction (self, WORM_DIRECTION_UP);
		result = TRUE;
		return result;
	}
	if (keyvalUpper == propsDown) {
		WormDirection _tmp11_;
		_tmp11_ = self->direction;
		_tmp10_ = _tmp11_ != WORM_DIRECTION_UP;
	} else {
		_tmp10_ = FALSE;
	}
	if (_tmp10_) {
		worm_handle_direction (self, WORM_DIRECTION_DOWN);
		result = TRUE;
		return result;
	}
	if (keyvalUpper == propsRight) {
		WormDirection _tmp13_;
		_tmp13_ = self->direction;
		_tmp12_ = _tmp13_ != WORM_DIRECTION_LEFT;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		worm_handle_direction (self, WORM_DIRECTION_RIGHT);
		result = TRUE;
		return result;
	}
	if (keyvalUpper == propsLeft) {
		WormDirection _tmp15_;
		_tmp15_ = self->direction;
		_tmp14_ = _tmp15_ != WORM_DIRECTION_RIGHT;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		worm_handle_direction (self, WORM_DIRECTION_LEFT);
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

void
worm_queue_keypress (Worm* self,
                     WormDirection dir)
{
	gboolean _tmp0_ = FALSE;
	GeeArrayQueue* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeArrayQueue* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->key_queue;
	_tmp2_ = gee_array_queue_get_is_empty (_tmp1_);
	_tmp3_ = _tmp2_;
	if (!_tmp3_) {
		GeeArrayQueue* _tmp4_;
		gpointer _tmp5_;
		_tmp4_ = self->priv->key_queue;
		_tmp5_ = gee_abstract_queue_peek ((GeeAbstractQueue*) _tmp4_);
		_tmp0_ = dir == ((WormDirection) ((gintptr) _tmp5_));
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	_tmp6_ = self->priv->key_queue;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, (gpointer) ((gintptr) dir));
}

void
worm_dequeue_keypress (Worm* self)
{
	GeeArrayQueue* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GeeArrayQueue* _tmp3_;
	gpointer _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->key_queue;
	_tmp1_ = gee_array_queue_get_is_empty (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_return_if_fail (!_tmp2_, "!key_queue.is_empty");
	_tmp3_ = self->priv->key_queue;
	_tmp4_ = gee_abstract_queue_poll ((GeeAbstractQueue*) _tmp3_);
	worm_direction_set (self, (WormDirection) ((gintptr) _tmp4_));
}

static gint
worm_ai_deadend (gint* board,
                 gint board_length1,
                 gint board_length2,
                 gint numworms,
                 gint x,
                 gint y,
                 gint length_left)
{
	gint cdir = 0;
	gint cx = 0;
	gint cy = 0;
	gint result = 0;
	if (x >= NIBBLES_GAME_WIDTH) {
		x = 0;
	}
	if (x < 0) {
		x = NIBBLES_GAME_WIDTH - 1;
	}
	if (y >= NIBBLES_GAME_HEIGHT) {
		y = 0;
	}
	if (y < 0) {
		y = NIBBLES_GAME_HEIGHT - 1;
	}
	if (length_left <= 0) {
		result = 0;
		return result;
	}
	cdir = 5;
	while (TRUE) {
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_ = FALSE;
		gint _tmp2_;
		cdir = cdir - 1;
		if (!(cdir > 0)) {
			break;
		}
		cx = x;
		cy = y;
		switch (cdir) {
			case WORM_DIRECTION_UP:
			{
				cy -= 1;
				break;
			}
			case WORM_DIRECTION_DOWN:
			{
				cy += 1;
				break;
			}
			case WORM_DIRECTION_LEFT:
			{
				cx -= 1;
				break;
			}
			case WORM_DIRECTION_RIGHT:
			{
				cx += 1;
				break;
			}
			default:
			break;
		}
		if (cx >= NIBBLES_GAME_WIDTH) {
			cx = 0;
		}
		if (cx < 0) {
			cx = NIBBLES_GAME_WIDTH - 1;
		}
		if (cy >= NIBBLES_GAME_HEIGHT) {
			cy = 0;
		}
		if (cy < 0) {
			cy = NIBBLES_GAME_HEIGHT - 1;
		}
		_tmp2_ = board[(cx * board_length2) + cy];
		if (_tmp2_ <= ((gint) NIBBLES_GAME_EMPTYCHAR)) {
			_tmp1_ = TRUE;
		} else {
			gint _tmp3_;
			_tmp3_ = board[(x * board_length2) + y];
			_tmp1_ = _tmp3_ >= ('z' + numworms);
		}
		if (_tmp1_) {
			guint* _tmp4_;
			gint _tmp4__length1;
			gint _tmp4__length2;
			guint _tmp5_;
			_tmp4_ = worm_deadend_board;
			_tmp4__length1 = worm_deadend_board_length1;
			_tmp4__length2 = worm_deadend_board_length2;
			_tmp5_ = _tmp4_[(cx * _tmp4__length2) + cy];
			_tmp0_ = _tmp5_ != worm_deadend_runnumber;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			guint* _tmp6_;
			gint _tmp6__length1;
			gint _tmp6__length2;
			_tmp6_ = worm_deadend_board;
			_tmp6__length1 = worm_deadend_board_length1;
			_tmp6__length2 = worm_deadend_board_length2;
			_tmp6_[(cx * _tmp6__length2) + cy] = worm_deadend_runnumber;
			length_left = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, cx, cy, length_left - 1);
			if (length_left <= 0) {
				result = 0;
				return result;
			}
		}
	}
	result = length_left;
	return result;
}

static gint
worm_ai_deadend_after (gint* board,
                       gint board_length1,
                       gint board_length2,
                       GeeLinkedList* worms,
                       gint numworms,
                       gint x,
                       gint y,
                       gint dir,
                       gint length)
{
	gint cx = 0;
	gint cy = 0;
	gint cl = 0;
	gint i = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	guint* _tmp17_;
	gint _tmp17__length1;
	gint _tmp17__length2;
	guint* _tmp18_;
	gint _tmp18__length1;
	gint _tmp18__length2;
	gint result = 0;
	g_return_val_if_fail (worms != NULL, 0);
	if (x < 0) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = x >= NIBBLES_GAME_WIDTH;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = y < 0;
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = y >= NIBBLES_GAME_HEIGHT;
	}
	if (_tmp0_) {
		result = 0;
		return result;
	}
	worm_deadend_runnumber = worm_deadend_runnumber + 1;
	if (dir > 4) {
		dir = 1;
	}
	if (dir < 1) {
		dir = 4;
	}
	i = numworms;
	while (TRUE) {
		gint _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		Position _tmp6_ = {0};
		Position _tmp7_;
		gpointer _tmp8_;
		Worm* _tmp9_;
		Position _tmp10_ = {0};
		Position _tmp11_;
		gboolean _tmp12_ = FALSE;
		_tmp3_ = i;
		i = _tmp3_ - 1;
		if (!(_tmp3_ > 0)) {
			break;
		}
		_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
		_tmp5_ = (Worm*) _tmp4_;
		worm_get_head (_tmp5_, &_tmp6_);
		_tmp7_ = _tmp6_;
		cx = _tmp7_.x;
		_g_object_unref0 (_tmp5_);
		_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
		_tmp9_ = (Worm*) _tmp8_;
		worm_get_head (_tmp9_, &_tmp10_);
		_tmp11_ = _tmp10_;
		cy = _tmp11_.y;
		_g_object_unref0 (_tmp9_);
		if (cx != x) {
			_tmp12_ = TRUE;
		} else {
			_tmp12_ = cy != y;
		}
		if (_tmp12_) {
			if (cx > 0) {
				guint* _tmp13_;
				gint _tmp13__length1;
				gint _tmp13__length2;
				_tmp13_ = worm_deadend_board;
				_tmp13__length1 = worm_deadend_board_length1;
				_tmp13__length2 = worm_deadend_board_length2;
				_tmp13_[((cx - 1) * _tmp13__length2) + cy] = worm_deadend_runnumber;
			}
			if (cy > 0) {
				guint* _tmp14_;
				gint _tmp14__length1;
				gint _tmp14__length2;
				_tmp14_ = worm_deadend_board;
				_tmp14__length1 = worm_deadend_board_length1;
				_tmp14__length2 = worm_deadend_board_length2;
				_tmp14_[(cx * _tmp14__length2) + (cy - 1)] = worm_deadend_runnumber;
			}
			if (cx < (NIBBLES_GAME_WIDTH - 1)) {
				guint* _tmp15_;
				gint _tmp15__length1;
				gint _tmp15__length2;
				_tmp15_ = worm_deadend_board;
				_tmp15__length1 = worm_deadend_board_length1;
				_tmp15__length2 = worm_deadend_board_length2;
				_tmp15_[((cx + 1) * _tmp15__length2) + cy] = worm_deadend_runnumber;
			}
			if (cy < (NIBBLES_GAME_HEIGHT - 1)) {
				guint* _tmp16_;
				gint _tmp16__length1;
				gint _tmp16__length2;
				_tmp16_ = worm_deadend_board;
				_tmp16__length1 = worm_deadend_board_length1;
				_tmp16__length2 = worm_deadend_board_length2;
				_tmp16_[(cx * _tmp16__length2) + (cy + 1)] = worm_deadend_runnumber;
			}
		}
	}
	cx = x;
	cy = y;
	switch (dir) {
		case WORM_DIRECTION_UP:
		{
			cy -= 1;
			break;
		}
		case WORM_DIRECTION_DOWN:
		{
			cy += 1;
			break;
		}
		case WORM_DIRECTION_LEFT:
		{
			cx -= 1;
			break;
		}
		case WORM_DIRECTION_RIGHT:
		{
			cx += 1;
			break;
		}
		default:
		break;
	}
	if (cx >= NIBBLES_GAME_WIDTH) {
		cx = 0;
	}
	if (cx < 0) {
		cx = NIBBLES_GAME_WIDTH - 1;
	}
	if (cy >= NIBBLES_GAME_HEIGHT) {
		cy = 0;
	}
	if (cy < 0) {
		cy = NIBBLES_GAME_HEIGHT - 1;
	}
	_tmp17_ = worm_deadend_board;
	_tmp17__length1 = worm_deadend_board_length1;
	_tmp17__length2 = worm_deadend_board_length2;
	_tmp17_[(x * _tmp17__length2) + y] = worm_deadend_runnumber;
	_tmp18_ = worm_deadend_board;
	_tmp18__length1 = worm_deadend_board_length1;
	_tmp18__length2 = worm_deadend_board_length2;
	_tmp18_[(cx * _tmp18__length2) + cy] = worm_deadend_runnumber;
	cl = (length * length) / 16;
	if (cl < NIBBLES_GAME_WIDTH) {
		cl = NIBBLES_GAME_WIDTH;
	}
	result = worm_ai_deadend (board, (gint) board_length1, (gint) board_length2, numworms, cx, cy, cl);
	return result;
}

static gboolean
worm_ai_too_close (Worm* self,
                   GeeLinkedList* worms,
                   gint numworms)
{
	gint i = 0;
	gint dx = 0;
	gint dy = 0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (worms != NULL, FALSE);
	i = numworms;
	while (TRUE) {
		gint _tmp0_;
		Position _tmp1_ = {0};
		Position _tmp2_;
		gpointer _tmp3_;
		Worm* _tmp4_;
		Position _tmp5_ = {0};
		Position _tmp6_;
		Position _tmp7_ = {0};
		Position _tmp8_;
		gpointer _tmp9_;
		Worm* _tmp10_;
		Position _tmp11_ = {0};
		Position _tmp12_;
		WormDirection _tmp13_;
		_tmp0_ = i;
		i = _tmp0_ - 1;
		if (!(_tmp0_ > 0)) {
			break;
		}
		worm_get_head (self, &_tmp1_);
		_tmp2_ = _tmp1_;
		_tmp3_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
		_tmp4_ = (Worm*) _tmp3_;
		worm_get_head (_tmp4_, &_tmp5_);
		_tmp6_ = _tmp5_;
		dx = _tmp2_.x - _tmp6_.x;
		_g_object_unref0 (_tmp4_);
		worm_get_head (self, &_tmp7_);
		_tmp8_ = _tmp7_;
		_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) worms, i);
		_tmp10_ = (Worm*) _tmp9_;
		worm_get_head (_tmp10_, &_tmp11_);
		_tmp12_ = _tmp11_;
		dy = _tmp8_.y - _tmp12_.y;
		_g_object_unref0 (_tmp10_);
		_tmp13_ = self->direction;
		switch (_tmp13_) {
			case WORM_DIRECTION_UP:
			{
				gboolean _tmp14_ = FALSE;
				gboolean _tmp15_ = FALSE;
				gboolean _tmp16_ = FALSE;
				if (dy > 0) {
					_tmp16_ = dy <= 3;
				} else {
					_tmp16_ = FALSE;
				}
				if (_tmp16_) {
					_tmp15_ = dx >= -1;
				} else {
					_tmp15_ = FALSE;
				}
				if (_tmp15_) {
					_tmp14_ = dx <= 1;
				} else {
					_tmp14_ = FALSE;
				}
				if (_tmp14_) {
					result = TRUE;
					return result;
				}
				break;
			}
			case WORM_DIRECTION_DOWN:
			{
				gboolean _tmp17_ = FALSE;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				if (dy < 0) {
					_tmp19_ = dy >= -3;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					_tmp18_ = dx >= -1;
				} else {
					_tmp18_ = FALSE;
				}
				if (_tmp18_) {
					_tmp17_ = dx <= 1;
				} else {
					_tmp17_ = FALSE;
				}
				if (_tmp17_) {
					result = TRUE;
					return result;
				}
				break;
			}
			case WORM_DIRECTION_LEFT:
			{
				gboolean _tmp20_ = FALSE;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp22_ = FALSE;
				if (dx > 0) {
					_tmp22_ = dx <= 3;
				} else {
					_tmp22_ = FALSE;
				}
				if (_tmp22_) {
					_tmp21_ = dy >= -1;
				} else {
					_tmp21_ = FALSE;
				}
				if (_tmp21_) {
					_tmp20_ = dy <= 1;
				} else {
					_tmp20_ = FALSE;
				}
				if (_tmp20_) {
					result = TRUE;
					return result;
				}
				break;
			}
			case WORM_DIRECTION_RIGHT:
			{
				gboolean _tmp23_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp25_ = FALSE;
				if (dx < 0) {
					_tmp25_ = dx >= -3;
				} else {
					_tmp25_ = FALSE;
				}
				if (_tmp25_) {
					_tmp24_ = dy >= -1;
				} else {
					_tmp24_ = FALSE;
				}
				if (_tmp24_) {
					_tmp23_ = dy <= 1;
				} else {
					_tmp23_ = FALSE;
				}
				if (_tmp23_) {
					result = TRUE;
					return result;
				}
				break;
			}
			default:
			break;
		}
	}
	result = FALSE;
	return result;
}

static gboolean
worm_ai_wander (gint* board,
                gint board_length1,
                gint board_length2,
                gint numworms,
                gint x,
                gint y,
                gint dir,
                gint ox,
                gint oy)
{
	gint _tmp0_;
	gboolean result = FALSE;
	if (dir > 4) {
		dir = 1;
	}
	if (dir < 1) {
		dir = 4;
	}
	switch (dir) {
		case WORM_DIRECTION_UP:
		{
			y = y - 1;
			break;
		}
		case WORM_DIRECTION_DOWN:
		{
			y = y + 1;
			break;
		}
		case WORM_DIRECTION_LEFT:
		{
			x = x - 1;
			break;
		}
		case WORM_DIRECTION_RIGHT:
		{
			x = x + 1;
			break;
		}
		default:
		break;
	}
	if (x >= NIBBLES_GAME_WIDTH) {
		x = 0;
	}
	if (x < 0) {
		x = NIBBLES_GAME_WIDTH - 1;
	}
	if (y >= NIBBLES_GAME_HEIGHT) {
		y = 0;
	}
	if (y < 0) {
		y = NIBBLES_GAME_HEIGHT - 1;
	}
	_tmp0_ = board[(x * board_length2) + y];
	switch (_tmp0_ - 'A') {
		case BONUS_TYPE_REGULAR:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_DOUBLE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_LIFE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_REVERSE:
		{
			result = TRUE;
			return result;
		}
		case BONUS_TYPE_HALF:
		{
			result = FALSE;
			return result;
		}
		default:
		{
			gboolean _tmp1_ = FALSE;
			gint _tmp2_;
			_tmp2_ = board[(x * board_length2) + y];
			if (_tmp2_ > ((gint) NIBBLES_GAME_EMPTYCHAR)) {
				gint _tmp3_;
				_tmp3_ = board[(x * board_length2) + y];
				_tmp1_ = _tmp3_ < ('z' + numworms);
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				result = FALSE;
				return result;
			} else {
				gboolean _tmp4_ = FALSE;
				if (ox == x) {
					_tmp4_ = oy == y;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					result = FALSE;
					return result;
				}
				result = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, x, y, dir, ox, oy);
				return result;
			}
		}
	}
}

void
worm_ai_move (Worm* self,
              gint* board,
              gint board_length1,
              gint board_length2,
              gint numworms,
              GeeLinkedList* worms)
{
	WormDirection opposite = 0;
	WormDirection _tmp0_;
	gboolean front = FALSE;
	Position _tmp1_ = {0};
	Position _tmp2_;
	Position _tmp3_ = {0};
	Position _tmp4_;
	WormDirection _tmp5_;
	Position _tmp6_ = {0};
	Position _tmp7_;
	Position _tmp8_ = {0};
	Position _tmp9_;
	gboolean left = FALSE;
	Position _tmp10_ = {0};
	Position _tmp11_;
	Position _tmp12_ = {0};
	Position _tmp13_;
	WormDirection _tmp14_;
	Position _tmp15_ = {0};
	Position _tmp16_;
	Position _tmp17_ = {0};
	Position _tmp18_;
	gboolean right = FALSE;
	Position _tmp19_ = {0};
	Position _tmp20_;
	Position _tmp21_ = {0};
	Position _tmp22_;
	WormDirection _tmp23_;
	Position _tmp24_ = {0};
	Position _tmp25_;
	Position _tmp26_ = {0};
	Position _tmp27_;
	gint dir = 0;
	WormDirection old_dir = 0;
	WormDirection _tmp33_;
	gint best_yet = 0;
	gint best_dir = 0;
	gint this_len = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (worms != NULL);
	_tmp0_ = self->direction;
	opposite = ((_tmp0_ + 1) % 4) + 1;
	worm_get_head (self, &_tmp1_);
	_tmp2_ = _tmp1_;
	worm_get_head (self, &_tmp3_);
	_tmp4_ = _tmp3_;
	_tmp5_ = self->direction;
	worm_get_head (self, &_tmp6_);
	_tmp7_ = _tmp6_;
	worm_get_head (self, &_tmp8_);
	_tmp9_ = _tmp8_;
	front = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, _tmp2_.x, _tmp4_.y, (gint) _tmp5_, _tmp7_.x, _tmp9_.y);
	worm_get_head (self, &_tmp10_);
	_tmp11_ = _tmp10_;
	worm_get_head (self, &_tmp12_);
	_tmp13_ = _tmp12_;
	_tmp14_ = self->direction;
	worm_get_head (self, &_tmp15_);
	_tmp16_ = _tmp15_;
	worm_get_head (self, &_tmp17_);
	_tmp18_ = _tmp17_;
	left = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, _tmp11_.x, _tmp13_.y, (gint) (_tmp14_ - 1), _tmp16_.x, _tmp18_.y);
	worm_get_head (self, &_tmp19_);
	_tmp20_ = _tmp19_;
	worm_get_head (self, &_tmp21_);
	_tmp22_ = _tmp21_;
	_tmp23_ = self->direction;
	worm_get_head (self, &_tmp24_);
	_tmp25_ = _tmp24_;
	worm_get_head (self, &_tmp26_);
	_tmp27_ = _tmp26_;
	right = worm_ai_wander (board, (gint) board_length1, (gint) board_length2, numworms, _tmp20_.x, _tmp22_.y, (gint) (_tmp23_ + 1), _tmp25_.x, _tmp27_.y);
	if (!front) {
		if (left) {
			WormDirection _tmp28_;
			_tmp28_ = self->direction;
			dir = (gint) (_tmp28_ - 1);
			if (dir < 1) {
				dir = 4;
			}
			self->direction = (WormDirection) dir;
		} else {
			if (right) {
				WormDirection _tmp29_;
				_tmp29_ = self->direction;
				dir = (gint) (_tmp29_ + 1);
				if (dir > 4) {
					dir = 1;
				}
				self->direction = (WormDirection) dir;
			} else {
				if (g_random_int_range ((gint32) 0, (gint32) 30) == ((gint32) 1)) {
					gint _tmp30_ = 0;
					WormDirection _tmp31_;
					WormDirection _tmp32_;
					if (g_random_boolean ()) {
						_tmp30_ = 1;
					} else {
						_tmp30_ = -1;
					}
					_tmp31_ = self->direction;
					dir = (gint) (_tmp31_ + _tmp30_);
					_tmp32_ = opposite;
					if (dir != ((gint) _tmp32_)) {
						if (dir > 4) {
							dir = 1;
						}
						if (dir < 1) {
							dir = 4;
						}
						self->direction = (WormDirection) dir;
					}
				}
			}
		}
	}
	_tmp33_ = self->direction;
	old_dir = _tmp33_;
	best_yet = NIBBLES_GAME_CAPACITY * 2;
	best_dir = -1;
	{
		gboolean _tmp34_ = FALSE;
		dir = 1;
		_tmp34_ = TRUE;
		while (TRUE) {
			WormDirection _tmp36_;
			Position _tmp37_ = {0};
			Position _tmp38_;
			Position _tmp39_ = {0};
			Position _tmp40_;
			gint _tmp41_;
			gint _tmp42_;
			gboolean _tmp43_ = FALSE;
			WormDirection _tmp44_;
			if (!_tmp34_) {
				gint _tmp35_;
				_tmp35_ = dir;
				dir = _tmp35_ + 1;
			}
			_tmp34_ = FALSE;
			if (!(dir <= 4)) {
				break;
			}
			self->direction = (WormDirection) dir;
			_tmp36_ = opposite;
			if (dir == ((gint) _tmp36_)) {
				continue;
			}
			this_len = 0;
			if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms)) {
				this_len += NIBBLES_GAME_CAPACITY;
			}
			if (worm_ai_too_close (self, worms, numworms)) {
				this_len += 4;
			}
			worm_get_head (self, &_tmp37_);
			_tmp38_ = _tmp37_;
			worm_get_head (self, &_tmp39_);
			_tmp40_ = _tmp39_;
			_tmp41_ = worm_get_length (self);
			_tmp42_ = _tmp41_;
			this_len += worm_ai_deadend_after (board, (gint) board_length1, (gint) board_length2, worms, numworms, _tmp38_.x, _tmp40_.y, dir, _tmp42_ + self->change);
			_tmp44_ = old_dir;
			if (dir == ((gint) _tmp44_)) {
				_tmp43_ = this_len <= 0;
			} else {
				_tmp43_ = FALSE;
			}
			if (_tmp43_) {
				this_len -= 100;
			}
			if (this_len <= 0) {
				this_len -= (gint) g_random_int_range ((gint32) 0, (gint32) 100);
			}
			if (this_len < best_yet) {
				best_yet = this_len;
				best_dir = dir;
			}
		}
	}
	self->direction = (WormDirection) best_dir;
	{
		gboolean _tmp45_ = FALSE;
		dir = 1;
		_tmp45_ = TRUE;
		while (TRUE) {
			WormDirection _tmp47_;
			if (!_tmp45_) {
				gint _tmp46_;
				_tmp46_ = dir;
				dir = _tmp46_ + 1;
			}
			_tmp45_ = FALSE;
			if (!(dir <= 4)) {
				break;
			}
			_tmp47_ = opposite;
			if (dir == ((gint) _tmp47_)) {
				continue;
			}
			if (!worm_can_move_to (self, board, (gint) board_length1, (gint) board_length2, numworms)) {
				self->direction = (WormDirection) dir;
			} else {
				continue;
			}
		}
	}
}

void
worm_get_starting_position (Worm* self,
                            Position * result)
{
	Position _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_starting_position;
	*result = _tmp0_;
	return;
}

static void
worm_set_starting_position (Worm* self,
                            Position * value)
{
	Position old_value;
	g_return_if_fail (self != NULL);
	worm_get_starting_position (self, &old_value);
	if (_position_equal (value, &old_value) != TRUE) {
		Position _tmp0_;
		_tmp0_ = *value;
		self->priv->_starting_position = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_STARTING_POSITION_PROPERTY]);
	}
}

gint
worm_get_id (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_id;
	return result;
}

static void
worm_set_id (Worm* self,
             gint value)
{
	g_return_if_fail (self != NULL);
	if (worm_get_id (self) != value) {
		self->priv->_id = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_ID_PROPERTY]);
	}
}

gboolean
worm_get_is_materialized (Worm* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_is_materialized;
	return result;
}

static void
worm_set_is_materialized (Worm* self,
                          gboolean value)
{
	g_return_if_fail (self != NULL);
	if (worm_get_is_materialized (self) != value) {
		self->priv->_is_materialized = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_IS_MATERIALIZED_PROPERTY]);
	}
}

gint
worm_get_lives (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_lives;
	return result;
}

void
worm_set_lives (Worm* self,
                gint value)
{
	g_return_if_fail (self != NULL);
	if (worm_get_lives (self) != value) {
		self->priv->_lives = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIVES_PROPERTY]);
	}
}

gint
worm_get_score (Worm* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_score;
	return result;
}

void
worm_set_score (Worm* self,
                gint value)
{
	g_return_if_fail (self != NULL);
	if (worm_get_score (self) != value) {
		self->priv->_score = value;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_SCORE_PROPERTY]);
	}
}

gint
worm_get_length (Worm* self)
{
	gint result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->priv->_list;
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
worm_set_length (Worm* self,
                 gint value)
{
	g_return_if_fail (self != NULL);
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LENGTH_PROPERTY]);
}

void
worm_get_head (Worm* self,
               Position * result)
{
	Position head = {0};
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
	Position* _tmp2_;
	Position _tmp3_;
	Position _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	_tmp1_ = gee_linked_list_first (_tmp0_);
	_tmp2_ = (Position*) _tmp1_;
	_tmp3_ = *_tmp2_;
	_position_free0 (_tmp2_);
	head = _tmp3_;
	_tmp4_ = head;
	*result = _tmp4_;
	return;
}

static void
worm_set_head (Worm* self,
               Position * value)
{
	GeeLinkedList* _tmp0_;
	Position _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_list;
	_tmp1_ = *value;
	gee_abstract_list_set ((GeeAbstractList*) _tmp0_, 0, &_tmp1_);
	g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_HEAD_PROPERTY]);
}

GeeLinkedList*
worm_get_list (Worm* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_list;
	result = _tmp0_;
	return result;
}

static void
worm_set_list (Worm* self,
               GeeLinkedList* value)
{
	g_return_if_fail (self != NULL);
	if (worm_get_list (self) != value) {
		GeeLinkedList* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_list);
		self->priv->_list = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, worm_properties[WORM_LIST_PROPERTY]);
	}
}

static void
worm_class_init (WormClass * klass,
                 gpointer klass_data)
{
	guint* _tmp0_;
	worm_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Worm_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_worm_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_worm_set_property;
	G_OBJECT_CLASS (klass)->finalize = worm_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_STARTING_POSITION_PROPERTY, worm_properties[WORM_STARTING_POSITION_PROPERTY] = g_param_spec_boxed ("starting-position", "starting-position", "starting-position", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_ID_PROPERTY, worm_properties[WORM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_IS_MATERIALIZED_PROPERTY, worm_properties[WORM_IS_MATERIALIZED_PROPERTY] = g_param_spec_boolean ("is-materialized", "is-materialized", "is-materialized", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIVES_PROPERTY, worm_properties[WORM_LIVES_PROPERTY] = g_param_spec_int ("lives", "lives", "lives", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_SCORE_PROPERTY, worm_properties[WORM_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LENGTH_PROPERTY, worm_properties[WORM_LENGTH_PROPERTY] = g_param_spec_int ("length", "length", "length", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_HEAD_PROPERTY, worm_properties[WORM_HEAD_PROPERTY] = g_param_spec_boxed ("head", "head", "head", TYPE_POSITION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), WORM_LIST_PROPERTY, worm_properties[WORM_LIST_PROPERTY] = g_param_spec_object ("list", "list", "list", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	worm_signals[WORM_ADDED_SIGNAL] = g_signal_new ("added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_FINISH_ADDED_SIGNAL] = g_signal_new ("finish-added", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_MOVED_SIGNAL] = g_signal_new ("moved", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_RESCALED_SIGNAL] = g_signal_new ("rescaled", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	worm_signals[WORM_DIED_SIGNAL] = g_signal_new ("died", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_TAIL_REDUCED_SIGNAL] = g_signal_new ("tail-reduced", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	worm_signals[WORM_REVERSED_SIGNAL] = g_signal_new ("reversed", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_BONUS_FOUND_SIGNAL] = g_signal_new ("bonus-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	worm_signals[WORM_WARP_FOUND_SIGNAL] = g_signal_new ("warp-found", TYPE_WORM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = g_new0 (guint, NIBBLES_GAME_WIDTH * NIBBLES_GAME_HEIGHT);
	worm_deadend_board = _tmp0_;
	worm_deadend_board_length1 = NIBBLES_GAME_WIDTH;
	worm_deadend_board_length2 = NIBBLES_GAME_HEIGHT;
}

static void
worm_instance_init (Worm * self,
                    gpointer klass)
{
	self->priv = worm_get_instance_private (self);
	self->keypress = FALSE;
	self->is_stopped = FALSE;
	self->priv->_is_materialized = TRUE;
}

static void
worm_finalize (GObject * obj)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WORM, Worm);
	_g_object_unref0 (self->priv->key_queue);
	_g_object_unref0 (self->priv->_list);
	G_OBJECT_CLASS (worm_parent_class)->finalize (obj);
}

GType
worm_get_type (void)
{
	static volatile gsize worm_type_id__volatile = 0;
	if (g_once_init_enter (&worm_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (WormClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) worm_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Worm), 0, (GInstanceInitFunc) worm_instance_init, NULL };
		GType worm_type_id;
		worm_type_id = g_type_register_static (G_TYPE_OBJECT, "Worm", &g_define_type_info, 0);
		Worm_private_offset = g_type_add_instance_private (worm_type_id, sizeof (WormPrivate));
		g_once_init_leave (&worm_type_id__volatile, worm_type_id);
	}
	return worm_type_id__volatile;
}

static void
_vala_worm_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
	switch (property_id) {
		case WORM_STARTING_POSITION_PROPERTY:
		{
			Position boxed;
			worm_get_starting_position (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case WORM_ID_PROPERTY:
		g_value_set_int (value, worm_get_id (self));
		break;
		case WORM_IS_MATERIALIZED_PROPERTY:
		g_value_set_boolean (value, worm_get_is_materialized (self));
		break;
		case WORM_LIVES_PROPERTY:
		g_value_set_int (value, worm_get_lives (self));
		break;
		case WORM_SCORE_PROPERTY:
		g_value_set_int (value, worm_get_score (self));
		break;
		case WORM_LENGTH_PROPERTY:
		g_value_set_int (value, worm_get_length (self));
		break;
		case WORM_HEAD_PROPERTY:
		{
			Position boxed;
			worm_get_head (self, &boxed);
			g_value_set_boxed (value, &boxed);
		}
		break;
		case WORM_LIST_PROPERTY:
		g_value_set_object (value, worm_get_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_worm_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Worm * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_WORM, Worm);
	switch (property_id) {
		case WORM_STARTING_POSITION_PROPERTY:
		worm_set_starting_position (self, g_value_get_boxed (value));
		break;
		case WORM_ID_PROPERTY:
		worm_set_id (self, g_value_get_int (value));
		break;
		case WORM_IS_MATERIALIZED_PROPERTY:
		worm_set_is_materialized (self, g_value_get_boolean (value));
		break;
		case WORM_LIVES_PROPERTY:
		worm_set_lives (self, g_value_get_int (value));
		break;
		case WORM_SCORE_PROPERTY:
		worm_set_score (self, g_value_get_int (value));
		break;
		case WORM_LENGTH_PROPERTY:
		worm_set_length (self, g_value_get_int (value));
		break;
		case WORM_HEAD_PROPERTY:
		worm_set_head (self, g_value_get_boxed (value));
		break;
		case WORM_LIST_PROPERTY:
		worm_set_list (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

